


/*------ 16.12.2000 23:06:44 --------*/

CREATE DOMAIN T_ID AS 
INTEGER
NOT NULL ;


/*------ 16.12.2000 23:07:01 --------*/

CREATE DOMAIN "T_Integer" AS 
INTEGER;


/*------ 16.12.2000 23:07:07 --------*/

DROP DOMAIN T_ID;


/*------ 16.12.2000 23:07:14 --------*/

CREATE DOMAIN "T_Id" AS 
INTEGER
NOT NULL ;


/*------ 16.12.2000 23:07:37 --------*/

CREATE DOMAIN "T_Name" AS 
VARCHAR(100) CHARACTER SET WIN1251 
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:08:03 --------*/

CREATE DOMAIN "T_Short_Name" AS 
VARCHAR(50) CHARACTER SET WIN1251 
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:08:26 --------*/

CREATE DOMAIN "T_Date" AS 
DATE
DEFAULT 'Today' ;


/*------ 16.12.2000 23:09:38 --------*/

CREATE DOMAIN "T_Payment" AS 
NUMERIC(15,2)
DEFAULT 0 ;


/*------ 16.12.2000 23:09:59 --------*/

CREATE TABLE "Projects" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:10:22 --------*/

ALTER TABLE "Projects"
ADD "Name" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:10:39 --------*/

ALTER TABLE "Projects"
ADD "Start Date" "T_Date";


/*------ 16.12.2000 23:11:05 --------*/

alter table "Projects"
add constraint PK_PROJECTS
primary key ("Id");


/*------ 16.12.2000 23:12:22 --------*/

CREATE DOMAIN "T_Memo" AS 
BLOB SUB_TYPE 1 SEGMENT SIZE 100 CHARACTER SET WIN1251 ;


/*------ 16.12.2000 23:12:48 --------*/

ALTER TABLE "Projects"
ADD "Signature" "T_Memo";


/*------ 16.12.2000 23:13:10 --------*/

ALTER TABLE "Projects"
ADD URL "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:13:21 --------*/

ALTER TABLE "Projects"
ADD "E-Mail" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:15:07 --------*/

CREATE TABLE "Users" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:15:29 --------*/

ALTER TABLE "Users"
ADD "First Name" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:15:39 --------*/

ALTER TABLE "Users"
ADD "Second Name" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:15:48 --------*/

ALTER TABLE "Users"
ADD "Nickname" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:16:20 --------*/

ALTER TABLE "Users"
ADD "Address" "T_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:16:33 --------*/

ALTER TABLE "Users"
ADD "Country" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:16:40 --------*/

alter table "Users" drop "Address";


/*------ 16.12.2000 23:16:51 --------*/

ALTER TABLE "Users"
ADD "Address" "T_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:16:59 --------*/

ALTER TABLE "Users"
ADD "Town" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:20:15 --------*/

ALTER TABLE "Users"
ADD "Company" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:20:27 --------*/

alter table "Users" drop "Nickname";


/*------ 16.12.2000 23:20:44 --------*/

ALTER TABLE "Users"
ADD "State" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:21:01 --------*/

ALTER TABLE "Users"
ADD ZIP "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:21:08 --------*/

ALTER TABLE "Users"
ADD "Phone" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:21:41 --------*/

alter table "Users"
add constraint PK_USERS
primary key ("Id");


/*------ 16.12.2000 23:22:15 --------*/

ALTER TABLE "Users"
ADD "E-Mail" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:22:55 --------*/

ALTER TABLE "Users" ALTER COLUMN "Town" TO "City";


/*------ 16.12.2000 23:24:38 --------*/

ALTER TABLE "Projects"
ADD "Registration Message" "T_Memo";


/*------ 16.12.2000 23:24:54 --------*/

ALTER TABLE "Projects"
ADD "Newsletter Template" "T_Memo";


/*------ 16.12.2000 23:25:56 --------*/

CREATE TABLE "Clients" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:26:16 --------*/

ALTER TABLE "Clients"
ADD "Id Project" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:27:12 --------*/

ALTER TABLE "Clients"
ADD "Entry Date" "T_Date";


/*------ 16.12.2000 23:27:57 --------*/

ALTER TABLE "Clients"
ADD "Id User" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:28:12 --------*/

alter table "Clients"
add constraint PK_CLIENTS
primary key ("Id");


/*------ 16.12.2000 23:28:49 --------*/

alter table "Clients"
add constraint FK_CLIENTS
foreign key ("Id Project")
references "Projects"("Id")
on delete CASCADE
on update CASCADE;


/*------ 16.12.2000 23:29:21 --------*/

alter table "Clients"
add constraint FK_CLIENTS_USERS
foreign key ("Id User")
references "Users"("Id")
on delete CASCADE
on update CASCADE;


/*------ 16.12.2000 23:30:04 --------*/

CREATE TABLE "Beta Testers" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:30:25 --------*/

ALTER TABLE "Beta Testers"
ADD "Id Project" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:30:32 --------*/

ALTER TABLE "Beta Testers"
ADD "Id User" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:31:11 --------*/

DROP TABLE "Beta Testers";


/*------ 16.12.2000 23:31:44 --------*/

CREATE DOMAIN "T_Boolean" AS 
SMALLINT
DEFAULT 0 
NOT NULL 
CHECK (Value in (0, 1)) ;


/*------ 16.12.2000 23:31:59 --------*/

ALTER TABLE "Clients"
ADD "Is Beta-Tester" "T_Boolean"
NOT NULL ;


/*------ 16.12.2000 23:32:21 --------*/

CREATE TABLE "Payments" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:32:35 --------*/

ALTER TABLE "Payments"
ADD "Id Project" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:33:11 --------*/

alter table "Payments" drop "Id Project";


/*------ 16.12.2000 23:33:23 --------*/

ALTER TABLE "Payments"
ADD "Id Client" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:33:41 --------*/

ALTER TABLE "Payments"
ADD "Payment" "T_Payment";


/*------ 16.12.2000 23:34:01 --------*/

ALTER TABLE "Payments"
ADD "Payment Date" "T_Date";


/*------ 16.12.2000 23:34:10 --------*/

alter table "Payments"
add constraint PK_PAYMENTS
primary key ("Id");


/*------ 16.12.2000 23:34:23 --------*/

alter table "Payments"
add constraint FK_PAYMENTS
foreign key ("Id Client")
references "Clients"("Id")
on delete CASCADE
on update CASCADE;


/*------ 16.12.2000 23:35:30 --------*/

CREATE DOMAIN "T_Payment_Method" AS 
VARCHAR(20) CHARACTER SET WIN1251 
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:35:41 --------*/

ALTER TABLE "Payments"
ADD "Payment Method" "T_Payment_Method"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:35:51 --------*/

alter table "Payments" drop "Payment Method";


/*------ 16.12.2000 23:36:21 --------*/

CREATE TABLE "Payment Methods" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:36:21 --------*/

CREATE GENERATOR "Payment Method GEN_Id";


/*------ 16.12.2000 23:36:21 --------*/

SET TERM ^ ;

CREATE TRIGGER "Payment Methods_BI" FOR "Payment Methods"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Payment Method GEN_Id",1);
END
^

SET TERM ; ^




/*------ 16.12.2000 23:36:36 --------*/

ALTER TABLE "Payment Methods"
ADD "Name" "T_Payment_Method"
COLLATE PXW_CYRL ;


/*------ 16.12.2000 23:36:52 --------*/

ALTER TABLE "Payments"
ADD "Id Payment Method" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:38:20 --------*/

alter table "Payment Methods"
add constraint "PK_PAYMENT METHODS"
primary key ("Id");


/*------ 16.12.2000 23:38:46 --------*/

alter table "Payments"
add constraint FK_PAYMENTS_PAYMENT_METHOD
foreign key ("Id Payment Method")
references "Payment Methods"("Id")
on delete CASCADE
on update CASCADE;


/*------ 16.12.2000 23:39:43 --------*/

CREATE GENERATOR "Client GEN_Id";


/*------ 16.12.2000 23:39:43 --------*/

SET TERM ^ ;

CREATE TRIGGER "Clients_BI" FOR "Clients"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Client GEN_Id",1);
END
^

SET TERM ; ^




/*------ 16.12.2000 23:40:40 --------*/

CREATE GENERATOR "Payments GEN_Id";


/*------ 16.12.2000 23:40:40 --------*/

SET TERM ^ ;

CREATE TRIGGER "Payments_BI" FOR "Payments"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Payments GEN_Id",1);
END
^

SET TERM ; ^




/*------ 16.12.2000 23:40:53 --------*/

CREATE GENERATOR "Projects GEN_Id";


/*------ 16.12.2000 23:40:53 --------*/

SET TERM ^ ;

CREATE TRIGGER "Projects_BI" FOR "Projects"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Projects GEN_Id",1);
END
^

SET TERM ; ^




/*------ 16.12.2000 23:41:08 --------*/

CREATE GENERATOR "Users GEN_Id";


/*------ 16.12.2000 23:41:08 --------*/

SET TERM ^ ;

CREATE TRIGGER "Users_BI" FOR "Users"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Users GEN_Id",1);
END
^

SET TERM ; ^




/*------ 16.12.2000 23:47:10 --------*/

create view "Client Payments" (
  "Id Project",
  "Id User",
  "Payment",
  "Payment Date",
  "Payment Method"
)
as
SELECT "Clients"."Id Project", "Clients"."Id User", "Payments"."Payment", "Payments"."Payment Date", "Payment Methods"."Name"
FROM "Clients"
   INNER JOIN "Payments" ON ("Clients"."Id" = "Payments"."Id Client")
   INNER JOIN "Payment Methods" ON ("Payments"."Id Payment Method" = "Payment Methods"."Id")
;


/*------ 16.12.2000 23:51:04 --------*/

create view "Project Clients" (
  "Id Project",
  "First Name",
  "Second Name",
  "Company",
  "E-Mail",
  "Address",
  "City",
  "State",
  "Country",
  ZIP,
  "Phone"
)
as
SELECT "Clients"."Id Project", "Users"."First Name", "Users"."Second Name", "Users"."Company", "Users"."E-Mail", "Users"."Address", "Users"."City", "Users"."State", "Users"."Country", "Users".ZIP, "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
;


/*------ 16.12.2000 23:52:45 --------*/

DROP VIEW "Project Clients";


/*------ 16.12.2000 23:52:45 --------*/

CREATE VIEW "Project Clients"(
    "Id Project",
    "First Name",
    "Second Name",
    "Company",
    "E-Mail",
    "Address",
    "City",
    "State",
    "Country",
    ZIP,
    "Phone")
AS
SELECT "Clients"."Id Project", "Users"."First Name", "Users"."Second Name", "Users"."Company", "Users"."E-Mail", "Users"."Address", "Users"."City", "Users"."State", "Users"."Country", "Users".ZIP, "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
where "Clients"."Is Beta-Tester" = 0


;


/*------ 16.12.2000 23:53:40 --------*/

CREATE VIEW "Project Testers"(
    "Id Project",
    "First Name",
    "Second Name",
    "Company",
    "E-Mail",
    "Address",
    "City",
    "State",
    "Country",
    ZIP,
    "Phone")
AS
SELECT "Clients"."Id Project", "Users"."First Name", "Users"."Second Name", "Users"."Company", "Users"."E-Mail", "Users"."Address", "Users"."City", "Users"."State", "Users"."Country", "Users".ZIP, "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
where "Clients"."Is Beta-Tester" = 1


;


;


/*------ 16.12.2000 23:53:47 --------*/

DROP VIEW "Project Testers";


/*------ 16.12.2000 23:53:47 --------*/

CREATE VIEW "Project Testers"(
    "Id Project",
    "First Name",
    "Second Name",
    "Company",
    "E-Mail",
    "Address",
    "City",
    "State",
    "Country",
    ZIP,
    "Phone")
AS
SELECT "Clients"."Id Project", "Users"."First Name", "Users"."Second Name", "Users"."Company", "Users"."E-Mail", "Users"."Address", "Users"."City", "Users"."State", "Users"."Country", "Users".ZIP, "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
where "Clients"."Is Beta-Tester" = 1


;


;


/*------ 16.12.2000 23:55:36 --------*/

SET TERM ^ ;

CREATE PROCEDURE "Test"
as
begin
  /* Procedure Text */
  suspend;
end;
^

SET TERM ; ^




/*------ 16.12.2000 23:55:38 --------*/

SET TERM ^ ;

ALTER PROCEDURE "Test"
as
begin
  /* Procedure Text */
  suspend;
end
^

SET TERM ; ^




/*------ 16.12.2000 23:55:49 --------*/

SET TERM ^ ;

ALTER PROCEDURE "Test"
as
begin
  /* Procedure Text */
  suspend;
end
^

SET TERM ; ^




/*------ 16.12.2000 23:56:04 --------*/

DROP VIEW "Project Clients";


/*------ 16.12.2000 23:56:04 --------*/

CREATE VIEW "Project Clients"(
    "Id Project",
    "First Name",
    "Second Name",
    "Company",
    "E-Mail",
    "Address",
    "City",
    "State",
    "Country",
    ZIP,
    "Phone")
AS
SELECT "Clients"."Id Project", "Users"."First Name", "Users"."Second Name", "Users"."Company", "Users"."E-Mail", "Users"."Address", "Users"."City", "Users"."State", "Users"."Country", "Users".ZIP, "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
where "Clients"."Is Beta-Tester" = 0


;


;


/*------ 16.12.2000 23:56:12 --------*/

DROP PROCEDURE "Test";


/*------ 16.12.2000 23:56:46 --------*/

CREATE TABLE "Newsletters" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:56:46 --------*/

CREATE GENERATOR "Newsletters GEN_Id";


/*------ 16.12.2000 23:56:46 --------*/

SET TERM ^ ;

CREATE TRIGGER "Newsletters_BI" FOR "Newsletters"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Newsletters GEN_Id",1);
END
^

SET TERM ; ^




/*------ 16.12.2000 23:56:56 --------*/

ALTER TABLE "Newsletters"
ADD "Id Project" "T_Id"
NOT NULL ;


/*------ 16.12.2000 23:57:16 --------*/

ALTER TABLE "Newsletters"
ADD "Message Text" "T_Memo";


/*------ 16.12.2000 23:57:25 --------*/

ALTER TABLE "Newsletters"
ADD "Entry Date" "T_Date";


/*------ 16.12.2000 23:59:26 --------*/

CREATE TABLE "Messages" (
"Id" "T_Id"
NOT NULL 
);


/*------ 16.12.2000 23:59:26 --------*/

CREATE GENERATOR "Messages GEN_Id";


/*------ 16.12.2000 23:59:26 --------*/

SET TERM ^ ;

CREATE TRIGGER "Messages_BI" FOR "Messages"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Messages GEN_Id",1);
END
^

SET TERM ; ^




/*------ 17.12.2000 00:00:17 --------*/

ALTER TABLE "Messages"
ADD "Message Text" "T_Memo";


/*------ 17.12.2000 00:00:33 --------*/

alter table "Newsletters"
add constraint PK_NEWSLETTERS
primary key ("Id");


/*------ 17.12.2000 00:00:52 --------*/

alter table "Newsletters"
add constraint FK_NEWSLETTERS
foreign key ("Id Project")
references "Projects"("Id")
on delete CASCADE
on update CASCADE;


/*------ 17.12.2000 00:01:04 --------*/

alter table "Messages"
add constraint PK_MESSAGES
primary key ("Id");


/*------ 17.12.2000 00:01:16 --------*/

CREATE TABLE "Messages List" (
"Id" "T_Id"
NOT NULL 
);


/*------ 17.12.2000 00:01:31 --------*/

CREATE GENERATOR "Messages List GEN_Id";


/*------ 17.12.2000 00:01:31 --------*/

SET TERM ^ ;

CREATE TRIGGER "Messages List_BI" FOR "Messages List"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Messages List GEN_Id",1);
END
^

SET TERM ; ^




/*------ 17.12.2000 00:01:37 --------*/

alter table "Messages List"
add constraint "PK_MESSAGES LIST"
primary key ("Id");


/*------ 17.12.2000 00:01:50 --------*/

ALTER TABLE "Messages List"
ADD "Id Message" "T_Id"
NOT NULL ;


/*------ 17.12.2000 00:02:25 --------*/

ALTER TABLE "Messages List"
ADD "Id Client" "T_Id"
NOT NULL ;


/*------ 17.12.2000 00:02:45 --------*/

alter table "Messages List"
add constraint "FK_MESSAGES LIST_MESSAGE"
foreign key ("Id Message")
references "Messages"("Id")
on delete CASCADE
on update CASCADE;


/*------ 17.12.2000 00:03:00 --------*/

alter table "Messages List"
add constraint "FK_MESSAGES LIST_CLIENT"
foreign key ("Id Client")
references "Clients"("Id")
on delete CASCADE
on update CASCADE;


/*------ 17.12.2000 00:48:05 --------*/

CREATE TABLE "News Servers" (
"Id" "T_Id"
NOT NULL 
);


/*------ 17.12.2000 00:48:06 --------*/

CREATE GENERATOR "News Servers GEN_Id";


/*------ 17.12.2000 00:48:06 --------*/

SET TERM ^ ;

CREATE TRIGGER "News Servers_BI" FOR "News Servers"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("News Servers GEN_Id",1);
END
^

SET TERM ; ^




/*------ 17.12.2000 00:48:20 --------*/

ALTER TABLE "News Servers"
ADD "Address" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 17.12.2000 00:49:09 --------*/

ALTER TABLE "News Servers"
ADD "Reply E-Mail" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 17.12.2000 00:50:32 --------*/

ALTER TABLE "News Servers"
ADD "Login" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 17.12.2000 00:50:40 --------*/

ALTER TABLE "News Servers"
ADD "Password" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 17.12.2000 00:51:11 --------*/

CREATE TABLE "News Servers List" (
"Id" "T_Id"
NOT NULL 
);


/*------ 17.12.2000 00:51:11 --------*/

CREATE GENERATOR "News Servers List GEN_Id";


/*------ 17.12.2000 00:51:11 --------*/

SET TERM ^ ;

CREATE TRIGGER "News Servers List_BI" FOR "News Servers List"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("News Servers List GEN_Id",1);
END
^

SET TERM ; ^




/*------ 17.12.2000 00:51:25 --------*/

ALTER TABLE "News Servers List"
ADD "Id News Server" "T_Id"
NOT NULL ;


/*------ 17.12.2000 00:51:38 --------*/

ALTER TABLE "News Servers List"
ADD "Id Project" "T_Id"
NOT NULL ;


/*------ 17.12.2000 00:51:50 --------*/

alter table "News Servers"
add constraint "PK_NEWS SERVERS"
primary key ("Id");


/*------ 17.12.2000 00:51:59 --------*/

alter table "News Servers List"
add constraint "PK_NEWS SERVERS LIST"
primary key ("Id");


/*------ 17.12.2000 00:52:17 --------*/

alter table "News Servers List"
add constraint "FK_NEWS SERVERS LIST_SERVER"
foreign key ("Id News Server")
references "News Servers"("Id")
on delete CASCADE
on update CASCADE;


/*------ 17.12.2000 00:52:35 --------*/

alter table "News Servers List"
add constraint "FK_NEWS SERVERS LIST_PROJECT"
foreign key ("Id Project")
references "Projects"("Id")
on delete CASCADE
on update CASCADE;


/*------ 17.12.2000 00:53:24 --------*/

ALTER TABLE "Projects"
ADD "POP3 Server" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 17.12.2000 00:53:35 --------*/

ALTER TABLE "Projects"
ADD "SMTP Server" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 17.12.2000 00:53:58 --------*/

ALTER TABLE "Projects"
ADD "Mail Login" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 17.12.2000 00:54:07 --------*/

ALTER TABLE "Projects"
ADD "Mail Password" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 23.12.2000 19:21:42 --------*/

DROP VIEW "Project Clients";


/*------ 23.12.2000 19:21:42 --------*/

CREATE VIEW "Project Clients"(
    "Id Project",
    "First Name",
    "Second Name",
    "Company",
    "E-Mail",
    "Address",
    "City",
    "State",
    "Country",
    ZIP,
    "Phone")
AS
SELECT "Clients"."Id Project",
       "Users"."First Name",
       "Users"."Second Name",
       "Users"."Company",
       "Users"."E-Mail",
       "Users"."Address",
       "Users"."City",
       "Users"."State",
       "Users"."Country",
       "Users".ZIP,
       "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
where "Clients"."Is Beta-Tester" = 0


;


;


/*------ 23.12.2000 19:22:45 --------*/

DROP VIEW "Project Clients";


/*------ 23.12.2000 19:22:45 --------*/

CREATE VIEW "Project Clients"(
    "Id Project",
    "First Name",
    "Second Name",
    "Company",
    "E-Mail",
    "Address",
    "City",
    "State",
    "Country",
    ZIP,
    "Phone")
AS
SELECT "Clients"."Id Project",
       "Users"."First Name",
       "Users"."Second Name",
       "Users"."Company",
       "Users"."E-Mail",
       "Users"."Address",
       "Users"."City",
       "Users"."State",
       "Users"."Country",
       "Users".ZIP,
       "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
where "Clients"."Is Beta-Tester" = 0


;


;


/*------ 23.12.2000 19:23:12 --------*/

DROP VIEW "Project Clients";


/*------ 23.12.2000 19:23:12 --------*/

CREATE VIEW "Project Clients"(
    "Id Project",
    "First Name",
    "SecondName",
    "Company",
    "E-Mail",
    "Address",
    "City",
    "State",
    "Country",
    ZIP,
    "Phone")
AS
SELECT "Clients"."Id Project",
       "Users"."First Name",
       "Users"."Second Name",
       "Users"."Company",
       "Users"."E-Mail",
       "Users"."Address",
       "Users"."City",
       "Users"."State",
       "Users"."Country",
       "Users".ZIP,
       "Users"."Phone"
FROM "Clients"
   INNER JOIN "Users" ON ("Clients"."Id User" = "Users"."Id")
where "Clients"."Is Beta-Tester" = 0


;


;


/*------ 23.12.2000 21:05:12 --------*/

ALTER TABLE "Clients"
ADD "RegCode" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 24.12.2000 03:03:57 --------*/

CREATE TABLE "Newsgroups" (
"Id" "T_Id"
NOT NULL 
);


/*------ 24.12.2000 03:03:57 --------*/

CREATE GENERATOR "Newsgroups_GEN_Id";


/*------ 24.12.2000 03:03:57 --------*/

SET TERM ^ ;

CREATE TRIGGER "Newsgroups_BI" FOR "Newsgroups"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("Newsgroups_GEN_Id",1);
END
^

SET TERM ; ^




/*------ 24.12.2000 03:04:14 --------*/

ALTER TABLE "Newsgroups"
ADD "Id Newsserver" "T_Id"
NOT NULL ;


/*------ 24.12.2000 03:04:28 --------*/

ALTER TABLE "Newsgroups"
ADD "Name" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 24.12.2000 03:04:51 --------*/

alter table "Newsgroups"
add constraint PK_NEWSGROUPS
primary key ("Id");


/*------ 24.12.2000 03:05:02 --------*/

alter table "Newsgroups"
add constraint FK_NEWSGROUPS
foreign key ("Id Newsserver")
references "News Servers"("Id")
on delete CASCADE
on update CASCADE;


/*------ 24.12.2000 03:06:54 --------*/

ALTER TABLE "Newsgroups"
ADD "Hash" "T_Integer";


/*------ 24.12.2000 03:07:07 --------*/

ALTER TABLE "News Servers"
ADD "Hash" "T_Integer";


/*------ 24.12.2000 03:07:20 --------*/

ALTER TABLE "News Servers"
ADD "IdParent" "T_Integer";


/*------ 24.12.2000 03:07:27 --------*/

alter table "News Servers" drop "IdParent";


/*------ 24.12.2000 03:07:41 --------*/

ALTER TABLE "News Servers"
ADD "IdParent" "T_Integer"
DEFAULT 0 ;


/*------ 24.12.2000 16:11:17 --------*/

DROP VIEW "Client Payments";


/*------ 24.12.2000 16:11:17 --------*/

CREATE VIEW "Client Payments"(
    "Id Project",
    "Id User",
    "Payment",
    "Payment Date",
    "Payment Method")
AS
SELECT "Clients"."Id Project", "Clients"."Id User", "Payments"."Payment", "Payments"."Payment Date", "Payment Methods"."Name"
FROM "Clients"
   INNER JOIN "Payments" ON ("Clients"."Id" = "Payments"."Id Client")
   INNER JOIN "Payment Methods" ON ("Payments"."Id Payment Method" = "Payment Methods"."Id")
;


;


/*------ 24.12.2000 16:12:24 --------*/

DROP VIEW "Client Payments";


/*------ 24.12.2000 16:12:24 --------*/

CREATE VIEW "Client Payments"(
    "Id Project",
    "Id User",
    "Payment",
    "Payment Date",
    "Payment Method")
AS
SELECT "Clients"."Id Project", "Clients"."Id User", "Payments"."Payment", "Payments"."Payment Date", "Payment Methods"."Name"
FROM "Clients"
   INNER JOIN "Payments" ON ("Clients"."Id" = "Payments"."Id Client")
   INNER JOIN "Payment Methods" ON ("Payments"."Id Payment Method" = "Payment Methods"."Id")
;


;


/*------ 24.12.2000 16:13:54 --------*/

DROP VIEW "Client Payments";


/*------ 24.12.2000 16:13:54 --------*/

CREATE VIEW "Client Payments"(
    "Id Project",
    "Id User",
    "Payment",
    "Payment Date",
    "Payment Method")
AS
SELECT "Clients"."Id Project", "Clients"."Id User", "Payments"."Payment", "Payments"."Payment Date", "Payment Methods"."Name"
FROM "Clients"
   INNER JOIN "Payments" ON ("Clients"."Id" = "Payments"."Id Client")
   INNER JOIN "Payment Methods" ON ("Payments"."Id Payment Method" = "Payment Methods"."Id")
;


;


/*------ 24.12.2000 20:54:07 --------*/

ALTER TABLE "Newsgroups"
ADD "Id Project" "T_Id"
NOT NULL ;


/*------ 24.12.2000 20:54:47 --------*/

alter table "Newsgroups"
add constraint FK_NEWSGROUPS_PROJECT
foreign key ("Id Project")
references "Projects"("Id")
on delete CASCADE
on update CASCADE;


/*------ 24.12.2000 20:57:04 --------*/

ALTER TABLE "Newsgroups" DROP CONSTRAINT FK_NEWSGROUPS_PROJECT;


/*------ 24.12.2000 20:57:23 --------*/

ALTER TABLE "Newsgroups" DROP CONSTRAINT FK_NEWSGROUPS;


/*------ 24.12.2000 20:57:33 --------*/

ALTER TABLE "Newsgroups" ALTER COLUMN "Id Newsserver" TO "Id Newsserver List";


/*------ 24.12.2000 20:57:37 --------*/

alter table "Newsgroups" drop "Id Project";


/*------ 24.12.2000 20:57:49 --------*/

alter table "Newsgroups"
add constraint FK_NEWSGROUPS
foreign key ("Id Newsserver List")
references "News Servers List"("Id")
on delete CASCADE
on update CASCADE;


/*------ 24.12.2000 20:59:35 --------*/

create view "Project News Groups" (
  "Name",
  "Id News Server",
  "Id Project"
)
as
SELECT
  "Newsgroups"."Name",
  "News Servers List"."Id News Server",
  "News Servers List"."Id Project"
FROM "News Servers List"
   INNER JOIN "Newsgroups" ON ("News Servers List"."Id" = "Newsgroups"."Id Newsserver List")
;


/*------ 24.12.2000 23:29:37 --------*/

DROP VIEW "Project News Servers";


/*------ 24.12.2000 23:29:37 --------*/

CREATE VIEW "Project News Servers"(
    "Id",
    "Id Project",
    "Id Server",
    "Address")
AS
SELECT
  "News Servers List"."Id",
  "News Servers List"."Id Project",
  "News Servers"."Id",
  "News Servers"."Address"
FROM "News Servers"
   INNER JOIN "News Servers List" ON ("News Servers"."Id" = "News Servers List"."Id News Server")
;


;


/*------ 24.12.2000 23:31:04 --------*/

DROP VIEW "Project News Servers";


/*------ 24.12.2000 23:31:04 --------*/

CREATE VIEW "Project News Servers"(
    "Id",
    "Id Project",
    "Id Server",
    "Address")
AS
SELECT
  "News Servers List"."Id",
  "News Servers List"."Id Project",
  "News Servers List"."Id News Server",
  "News Servers"."Address"
FROM "News Servers"
   INNER JOIN "News Servers List" ON ("News Servers"."Id" = "News Servers List"."Id News Server")
;


;


/*------ 25.12.2000 11:16:09 --------*/

CREATE TABLE "Newsletters Logging" (
"Id" "T_Id"
NOT NULL 
);


/*------ 25.12.2000 11:16:09 --------*/

CREATE GENERATOR "News_logging_GEN_Id";


/*------ 25.12.2000 11:16:09 --------*/

SET TERM ^ ;

CREATE TRIGGER "Newsletters Logging_BI" FOR "Newsletters Logging"
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW."Id" IS NULL) THEN
      NEW."Id" = GEN_ID("News_logging_GEN_Id",1);
END
^

SET TERM ; ^




/*------ 25.12.2000 11:16:45 --------*/

ALTER TABLE "Newsletters Logging"
ADD "Id Newsletter" "T_Id"
NOT NULL ;


/*------ 25.12.2000 11:17:24 --------*/

ALTER TABLE "Newsletters Logging"
ADD "Id User" "T_Id"
NOT NULL ;


/*------ 25.12.2000 11:20:30 --------*/

ALTER TABLE "Newsletters"
ADD "Subject" "T_Short_Name"
COLLATE PXW_CYRL ;


/*------ 25.12.2000 11:28:54 --------*/

alter table "Newsletters Logging"
add constraint "PK_NEWSLETTERS LOGGING"
primary key ("Id");


/*------ 25.12.2000 11:29:47 --------*/

alter table "Newsletters Logging"
add constraint "FK_NEWSLETTERS LOGGING_NEWS"
foreign key ("Id Newsletter")
references "Newsletters"("Id")
on delete CASCADE
on update CASCADE;


/*------ 25.12.2000 11:30:21 --------*/

alter table "Newsletters Logging"
add constraint "FK_NEWSLETTERS LOGGING_USERS"
foreign key ("Id User")
references "Users"("Id")
on delete CASCADE
on update CASCADE;


/*------ 26.12.2000 00:57:55 --------*/

alter table "News Servers" drop "IdParent";


/*------ 26.12.2000 00:57:58 --------*/

alter table "News Servers" drop "Hash";