unit ClientF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SohoBtns, SoCtrls, OkCancelHelpF, SoChkBox, SoCtmRgs, SoIBRgst,
  SoCtmDBGuide, SoIBGuide, DB, FIBDataSet, pFIBDataSet, SoIBClasses,
  FIBDatabase, pFIBDatabase, SoCtmDBAssist, SohoIBAssist;

type
  TClientForm = class(TForm)
    sohoLabel1: TsohoLabel;
    sohoLabel2: TsohoLabel;
    TesterC: TsohoCheckBox;
    OkCancelHelpFrame1: TOkCancelHelpFrame;
    NameE: TsohoEdit;
    DateE: TsohoEdit;
    SelectB: TsohoBitBtn;
    NewUserB: TsohoBitBtn;
    Reg: TsohoIBSubRegister;
    IBAssist: TsohoIBAssist;
    NewTr: TsohoIBTransaction;
    NewDS: TsohoIBDataSet;
    sohoLabel3: TsohoLabel;
    RegCodeE: TsohoEdit;
    GenB: TsohoBitBtn;
    sohoCheckBox1: TsohoCheckBox;
    CheckB: TsohoBitBtn;
    procedure SelectBClick(Sender: TObject);
    procedure NewUserBClick(Sender: TObject);
    procedure RegActivate(Sender: TObject);
    procedure IBAssistGetValue(Sender: TObject; const FieldName: String;
      var FieldValue: String);
    procedure GenBClick(Sender: TObject);
  private
    { Private declarations }
    function EditClient(DataSet: TDataSet): boolean;
    function NewClient(DataSet: TDataSet): Integer;
  public
    { Public declarations }
    UserId: Integer;
    FName, SName, CName: string;
  end;

var
  ClientForm: TClientForm;

function EditClient(DataSet: TDataSet): boolean;
function NewClient(DataSet: TDataSet): Integer;

implementation
uses Main, SoIBRtn, SoAppUtils, SoVCLUtils, UserF, RegCode;

{$R *.DFM}

function EditClient(DataSet: TDataSet): boolean;
begin
  try
    ClientForm := TClientForm.Create(Application);
    Result := ClientForm.EditClient(DataSet);
  finally
    ClientForm.Free;
  end;
end;

function NewClient(DataSet: TDataSet): Integer;
begin
  try
    ClientForm := TClientForm.Create(Application);
    Result := ClientForm.NewClient(DataSet);
  finally
    ClientForm.Free;
  end;
end;

procedure TClientForm.SelectBClick(Sender: TObject);
var Query: TpFIBDataSet;
begin
  if not MainForm.UsersGuide.Execute(MainForm.RefreshUsers, true, true) then exit;
  MainForm.RefreshUsers := false;
  UserId := MainForm.UsersGuide.ItemId;
  Query := GetQuery(Reg.PathToSQL + 'Get name of user.sql',
    MainForm.MainDB,
    TsohoIBGuideForm(MainForm.UsersGuide.GuideForm).Transaction, [IntToStr(UserId)]);
  NameE.AsString := '';
  if Query <> nil then begin
    FName := Query.FieldByName('First Name').AsString;
    SName := Query.FieldByName('Second Name').AsString;
    CName := Query.FieldByName('Company').AsString;
    NameE.AsString := FName + ' ' + SName + '(' + CName +')';
  end;
end;

procedure TClientForm.NewUserBClick(Sender: TObject);
var Tr: TsohoIBTransaction;
begin
  UserId := NewUser(nil);
  if UserId = -1 then exit;
  MainForm.RefreshUsers := true;
  if MainForm.UsersGuide.GuideForm <> nil then
    Tr := TsohoIBGuideForm(MainForm.UsersGuide.GuideForm).Transaction
  else
    Tr := nil;
  NameE.AsString := GetSQLResult(Reg.PathToSQL + 'Get full name of user.sql',
    MainForm.MainDB, Tr, [IntToStr(UserId)]);
end;

function TClientForm.EditClient(DataSet: TDataSet): boolean;
begin
  IBAssist.DataSet := DataSet;
  IBAssist.ReadData;

  UserId := DataSet.FieldByName('Id User').AsInteger;
  FName := DataSet.FieldByName('First Name').AsString;
  SName := DataSet.FieldByName('Second Name').AsString;
  CName := DataSet.FieldByName('Company').AsString;
  NameE.AsString := FName + ' ' + SName + '(' + CName +')';
  Result := ShowModal = mrOk;
  if not Result then exit;
  IBAssist.UpdateData;
end;

function TClientForm.NewClient(DataSet: TDataSet): Integer;
var OkClose: boolean;
begin
  Result := -1;
  IBAssist.DataSet := DataSet;
  if IBAssist.DataSet = nil then begin
    IBAssist.DataSet := NewDS;
    NewTr.StartTransaction;
    NewDS.Open;
  end;
  OkClose := ShowModal = mrOk;
  if not OkClose then begin
    if NewTr.InTransaction then NewTr.Rollback;
    exit;
  end;
  IBAssist.InsertData;
  Result := IBAssist.KeyValue;
  if NewTr.InTransaction then NewTr.Commit;
end;

procedure TClientForm.RegActivate(Sender: TObject);
begin
  NewDS.SelectSQL.LoadFromFile(Reg.PathToSQL + 'Get clients.sql');
end;

procedure TClientForm.IBAssistGetValue(Sender: TObject;
  const FieldName: String; var FieldValue: String);
begin
  if FieldName = 'Id Project' then
    FieldValue := IntToStr(MainForm.CurrentProject);
  if FieldName = 'Id User' then
    FieldValue := IntToStr(UserId);
end;

procedure TClientForm.GenBClick(Sender: TObject);
begin
  RegCodeE.AsString := CalculatePassWord(FName, SName, CName);
end;

end.
