unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, SoDialogs,
  ComCtrls, SoStatusBar, TB97, ActnList, Menus, SohoApp, SoAbout,
  SoFrmStorage, ImgList, TB97Tlbr, TB97Ctls, FIBDatabase, pFIBDatabase,
  SoIBClasses, SoCtmRgs, SoIBRgst, pFIBErrorHandler, FIB, SoGauges,
  SoCtmDBGuide, SoIBGuide, Global, Db, FIBDataSet, pFIBDataSet, FIBQuery,
  SoDBGrid, SohoSpin;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MainActions: TActionList;
    Dock971: TDock97;
    Dock972: TDock97;
    Dock973: TDock97;
    StatusBar: TsohoStatusBar;
    App: TsohoApplication;
    MainIni: TsohoFormStorage;
    AboutBox: TsohoAboutBox;
    AboutBoxA: TAction;
    ContentsA: TAction;
    NewProject: TAction;
    ProjectPropertiesA: TAction;
    DeleteProjectA: TAction;
    ExitA: TAction;
    NewUserA: TAction;
    ViewUsersA: TAction;
    NewClientA: TAction;
    ViewClientsA: TAction;
    NewsletterA: TAction;
    NewPaymentA: TAction;
    ViewPaymentsA: TAction;
    Projects1: TMenuItem;
    Users1: TMenuItem;
    Clients1: TMenuItem;
    Help1: TMenuItem;
    NewProject1: TMenuItem;
    ProjectProperties1: TMenuItem;
    DeleteProject1: TMenuItem;
    OpenProjectA: TAction;
    OpenProject1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    NewUser1: TMenuItem;
    ViewUsers1: TMenuItem;
    NewClient1: TMenuItem;
    ViewClients1: TMenuItem;
    N2: TMenuItem;
    SendNewsletter1: TMenuItem;
    N3: TMenuItem;
    NewPayment1: TMenuItem;
    ViewPayments1: TMenuItem;
    Logging1: TMenuItem;
    ViewNewslettersA: TAction;
    ViewMessagesA: TAction;
    NewMessageA: TAction;
    NewMessage1: TMenuItem;
    ViewNewsletters1: TMenuItem;
    ViewMessages1: TMenuItem;
    Contents1: TMenuItem;
    About1: TMenuItem;
    MainToolbar: TToolbar97;
    ToolbarButton971: TToolbarButton97;
    ToolbarButton972: TToolbarButton97;
    ToolbarButton973: TToolbarButton97;
    ToolbarButton974: TToolbarButton97;
    ToolbarSep971: TToolbarSep97;
    ToolbarButton975: TToolbarButton97;
    ToolbarButton976: TToolbarButton97;
    ToolbarSep972: TToolbarSep97;
    ToolbarButton977: TToolbarButton97;
    ToolbarButton978: TToolbarButton97;
    ToolbarSep973: TToolbarSep97;
    ToolbarButton979: TToolbarButton97;
    ToolbarButton9710: TToolbarButton97;
    ToolbarSep974: TToolbarSep97;
    ToolbarButton9711: TToolbarButton97;
    ToolbarButton9712: TToolbarButton97;
    MenuImages: TImageList;
    N4: TMenuItem;
    ToolbarSep975: TToolbarSep97;
    MainDB: TsohoIBDatabase;
    MainTr: TsohoIBTransaction;
    Reg: TsohoIBRegister;
    ErrorHandler: TpFibErrorHandler;
    ProjectsGuide: TsohoIBGuide;
    Gauge: TsohoGauge;
    UsersGuide: TsohoIBGuide;
    N5: TMenuItem;
    NewsServersA: TAction;
    NewsServers1: TMenuItem;
    ToolbarButton9713: TToolbarButton97;
    ServersGuide: TsohoIBGuide;
    ClientsGuide: TsohoIBGuide;
    ClientsFilter: TPopupMenu;
    ViewClientsM: TMenuItem;
    ViewBetaTestersM: TMenuItem;
    PaymentsGuide: TsohoIBGuide;
    procedure ExitAExecute(Sender: TObject);
    procedure AboutBoxAExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ErrorHandlerFIBErrorEvent(Sender: TObject;
      ErrorValue: EFIBError; KindIBError: TKindIBError;
      var DoRaise: Boolean);
    procedure NewProjectExecute(Sender: TObject);
    procedure OpenProjectAExecute(Sender: TObject);
    procedure ProjectPropertiesAExecute(Sender: TObject);
    procedure DeleteProjectAExecute(Sender: TObject);
    procedure ProjectPropertiesAUpdate(Sender: TObject);
    procedure ViewUsersAExecute(Sender: TObject);
    procedure NewsServersAExecute(Sender: TObject);
    procedure RegActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function UsersGuideOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    procedure NewUserAExecute(Sender: TObject);
    procedure ViewClientsAExecute(Sender: TObject);
    procedure ClientsGuideBeforeQueryOpen(DataSet: TDataSet);
    function ClientsGuideOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    procedure NewClientAExecute(Sender: TObject);
    procedure ViewClientsMClick(Sender: TObject);
    procedure ViewBetaTestersMClick(Sender: TObject);
    procedure ClientsGuideFilter(DataSet: TDataSet; var Accept: Boolean);
    procedure NewsletterAExecute(Sender: TObject);
    procedure PaymentsGuideBeforeQueryOpen(DataSet: TDataSet);
    procedure ViewPaymentsAExecute(Sender: TObject);
    function PaymentsGuideOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    procedure NewPaymentAExecute(Sender: TObject);
  private
    { Private declarations }
    procedure SetCurrentId(const Value: Integer);
    function GetCurrentId: Integer;
    function GetProjectName: string;
  public
    { Public declarations }
    RefreshUsers: boolean;
    RefreshClients: boolean;
    RefreshPayments: boolean;

    ViewClients, ViewTesters: boolean;
    property ProjectName: string read GetProjectName;
    property CurrentProject: Integer read GetCurrentId write SetCurrentId;
  end;

var
  MainForm: TMainForm;

implementation
uses SoVCLUtils, SoIBRtn, SoUnit, SoStrUtils, SoIBIdent, SoAppUtils,
     ProjOptionsF, UserF, ClientF, SoDBRtn, NewsletterF, PaymentF;

{$R *.DFM}

procedure TMainForm.ExitAExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.AboutBoxAExecute(Sender: TObject);
begin
  AboutBox.Execute;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IniSaveToolbarPositions(Self, DefaultIniName, 'Toolbar');
  ProjectOptions.Id := -1;
  if MainTr.InTransaction then MainTr.Commit;
  MainDB.Close;
end;

procedure TMainForm.ErrorHandlerFIBErrorEvent(Sender: TObject;
  ErrorValue: EFIBError; KindIBError: TKindIBError; var DoRaise: Boolean);
begin
  if KindIBError <> keException then exit;
  ErrorMsg(ErrorValue.Message);
  DoRaise := false;
end;

procedure TMainForm.NewProjectExecute(Sender: TObject);
var NewProjName: string;
    NewProjId: Integer;
begin
  NewProjName := 'New project name';
  repeat
    if not InputQuery('New Project', 'Enter new name', NewProjName) then exit;
  until Trim(NewProjName) <> '';

  NewProjId := GetNewId('Projects GEN_Id');
  if ExecuteSQLText('insert into "Projects" ("Id", "Name") values (' +
    IntToStr(NewProjId) + ', ' + SingleQuotes(NewProjName) + ')', MainDB,
    nil, NillParams) then
     CurrentProject := NewProjId;
end;

procedure TMainForm.SetCurrentId(const Value: Integer);
begin
  ProjectOptions.Id := Value;
  if ProjectOptions.Id = -1 then Caption := 'Support Center'
  else Caption := 'Support Center - [' + ProjectOptions.Name + ']';
  RefreshUsers := true;
  RefreshClients := true;
  RefreshPayments := true;
end;

procedure TMainForm.OpenProjectAExecute(Sender: TObject);
begin
  if not ProjectsGuide.Execute(false, true, true) then exit;
  if ProjectsGuide.ItemId = -1 then exit;
  CurrentProject := ProjectsGuide.ItemId;
end;

procedure TMainForm.ProjectPropertiesAExecute(Sender: TObject);
begin
  ExecuteOptions;
  ProjectOptions.SaveSettings;
  ProjectOptions.LoadSettings; // Refresh options from server
end;

procedure TMainForm.DeleteProjectAExecute(Sender: TObject);
begin
  if not YesNoMsg('Are you sure you want to delete project "' +
    ProjectName + '"?') then exit;
  if ExecuteSQL(Reg.PathToSQL + 'Delete Current Project.sql', MainDB, nil,
   [IntToStr(CurrentProject)]) then CurrentProject := -1;
end;

procedure TMainForm.ProjectPropertiesAUpdate(Sender: TObject);
begin
  ProjectPropertiesA.Enabled := CurrentProject <> -1;
  DeleteProjectA.Enabled := CurrentProject <> -1;
  NewClientA.Enabled := CurrentProject <> -1;
  ViewClientsA.Enabled := CurrentProject <> -1;
  NewsletterA.Enabled := CurrentProject <> -1;
  NewPaymentA.Enabled := CurrentProject <> -1;
  ViewNewslettersA.Enabled := CurrentProject <> -1;
  NewMessageA.Enabled := CurrentProject <> -1;
  ViewMessagesA.Enabled := CurrentProject <> -1;
  ViewPaymentsA.Enabled := CurrentProject <> -1;
end;

procedure TMainForm.ViewUsersAExecute(Sender: TObject);
begin
  UsersGuide.Execute(RefreshUsers, true, false);
  RefreshUsers := false;
end;

procedure TMainForm.NewsServersAExecute(Sender: TObject);
begin
  ServersGuide.Execute(false, true, false);
end;

procedure TMainForm.RegActivate(Sender: TObject);
begin
  ProjectOptions := TProject.Create(Self);
  ProjectOptions.Database := MainDB;
  ProjectOptions.Transaction := MainTr;
  ProjectOptions.Id := -1;
  IniLoadToolbarPositions(Self, DefaultIniName, 'Toolbar');
  RefreshUsers := false;
  RefreshClients := false;
  ViewClients := true;
  ViewTesters := true;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  ProjectOptions.Free;
end;

function TMainForm.GetCurrentId: Integer;
begin
  Result := ProjectOptions.Id;
end;

function TMainForm.GetProjectName: string;
begin
  Result := ProjectOptions.Name;
end;

function TMainForm.UsersGuideOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
begin
  case Operation of
    soNewRecord: Result := NewUser(UsersGuide.ItemsQuery) <> -1;
    soEditRecord: Result := EditUser(UsersGuide.ItemsQuery);
    else begin
      Result := YesNoMsg('Are you sure you want to delete user: ' +
        UsersGuide.ItemsQuery.FieldByName('First Name').AsString + ' ' +
        UsersGuide.ItemsQuery.FieldByName('Second Name').AsString + '?');
      if Result then
        Result := ExecuteSQL(Reg.PathToSQL + 'Delete user.sql', MainDB,
          TsohoIBGuideForm(UsersGuide.GuideForm).Transaction, [
            IntToStr(UsersGuide.ItemId)]);
    end;
  end;
  if Result then
    TsohoIBGuideForm(UsersGuide.GuideForm).Transaction.CommitRetaining;
end;

procedure TMainForm.NewUserAExecute(Sender: TObject);
begin
  if NewUser(nil) <> -1 then RefreshUsers := true;
end;

procedure TMainForm.ViewClientsAExecute(Sender: TObject);
begin
  ClientsGuide.Execute(RefreshClients, true, false);
  RefreshClients := false;
end;

procedure TMainForm.ClientsGuideBeforeQueryOpen(DataSet: TDataSet);
begin
  TsohoIBDataSet(DataSet).Params[0].AsInteger := CurrentProject; 
end;

function TMainForm.ClientsGuideOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
begin
  case Operation of
    soNewRecord: Result := NewClient(ClientsGuide.ItemsQuery) <> -1;
    soEditRecord: Result := EditClient(ClientsGuide.ItemsQuery);
    else begin
      Result := YesNoMsg('Are you sure you want to delete client: ' +
        ClientsGuide.ItemsQuery.FieldByName('First Name').AsString + ' ' +
        ClientsGuide.ItemsQuery.FieldByName('Second Name').AsString + '?');
      if Result then
        Result := ExecuteSQL(Reg.PathToSQL + 'Delete client.sql', MainDB,
          TsohoIBGuideForm(ClientsGuide.GuideForm).Transaction, [
            IntToStr(ClientsGuide.ItemId)]);
    end;
  end;
  if Result then
    TsohoIBGuideForm(ClientsGuide.GuideForm).Transaction.CommitRetaining;
end;

procedure TMainForm.NewClientAExecute(Sender: TObject);
begin
  if NewClient(nil) <> -1 then RefreshClients := true;
end;

procedure TMainForm.ViewClientsMClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
  ViewClients := (Sender as TMenuItem).Checked;
  RefreshDataSetFilter(ClientsGuide.ItemsQuery);
end;

procedure TMainForm.ViewBetaTestersMClick(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
  ViewTesters := (Sender as TMenuItem).Checked;
  RefreshDataSetFilter(ClientsGuide.ItemsQuery);
end;

procedure TMainForm.ClientsGuideFilter(DataSet: TDataSet;
  var Accept: Boolean);
begin
  Accept := (ViewClients and
             (not DataSet.FieldByName('Is Beta-Tester').AsBoolean)) or
            (ViewTesters and
                  DataSet.FieldByName('Is Beta-Tester').AsBoolean);
end;

procedure TMainForm.NewsletterAExecute(Sender: TObject);
begin
  //   ,    -
  SendNewsLetter;
end;

procedure TMainForm.PaymentsGuideBeforeQueryOpen(DataSet: TDataSet);
begin
  TsohoIBDataSet(DataSet).Params[0].AsInteger := ProjectOptions.Id;
end;

procedure TMainForm.ViewPaymentsAExecute(Sender: TObject);
begin
  PaymentsGuide.Execute(RefreshPayments, true, false);
  RefreshPayments := false;
end;

function TMainForm.PaymentsGuideOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
begin
  case Operation of
    soNewRecord: Result := NewPayment(PaymentsGuide.ItemsQuery) <> -1;
    soEditRecord: Result := EditPayment(PaymentsGuide.ItemsQuery);
    else begin
      Result := YesNoMsg('Are you sure you want to delete payment of client: ' +
        PaymentsGuide.ItemsQuery.FieldByName('First Name').AsString + ' ' +
        PaymentsGuide.ItemsQuery.FieldByName('Second Name').AsString + '?');
      if Result then
        Result := ExecuteSQL(Reg.PathToSQL + 'Delete payment.sql', MainDB,
          TsohoIBGuideForm(PaymentsGuide.GuideForm).Transaction, [
            IntToStr(PaymentsGuide.ItemId)]);
    end;
  end;
  if Result then
    TsohoIBGuideForm(PaymentsGuide.GuideForm).Transaction.CommitRetaining;
end;

procedure TMainForm.NewPaymentAExecute(Sender: TObject);
begin
  RefreshPayments := NewPayment(nil) <> -1;
end;

end.
