unit PaymentF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SoCtrls, OkCancelHelpF, SohoBtns, SoCtmCmb, SoIbComb, Db,
  FIBDataSet, pFIBDataSet, SoIBClasses, FIBDatabase, pFIBDatabase,
  SoCtmDBAssist, SohoIBAssist, SoCtmRgs, SoIBRgst;

type
  TPaymentForm = class(TForm)
    sohoLabel1: TsohoLabel;
    sohoLabel2: TsohoLabel;
    sohoLabel3: TsohoLabel;
    sohoLabel4: TsohoLabel;
    ClientsC: TsohoIBComboBox;
    NewClientB: TsohoBitBtn;
    DateE: TsohoEdit;
    SumE: TsohoEdit;
    OkCancelHelpFrame1: TOkCancelHelpFrame;
    NewTr: TsohoIBTransaction;
    NewDS: TsohoIBDataSet;
    PayMethodC: TsohoIBComboBox;
    IBAssist: TsohoIBAssist;
    Reg: TsohoIBSubRegister;
    procedure ClientsCBeforeOpen(DataSet: TDataSet);
    procedure RegActivate(Sender: TObject);
    procedure NewClientBClick(Sender: TObject);
  private
    { Private declarations }
    function EditPayment(DataSet: TDataSet): boolean;
    function NewPayment(DataSet: TDataSet): Integer;
    procedure PrepareCombo;
  public
    { Public declarations }
  end;

var
  PaymentForm: TPaymentForm;

function EditPayment(DataSet: TDataSet): boolean;
function NewPayment(DataSet: TDataSet): Integer;

implementation
uses Main, Global, ClientF;

{$R *.DFM}

function EditPayment(DataSet: TDataSet): boolean;
begin
  try
    PaymentForm := TPaymentForm.Create(Application);
    Result := PaymentForm.EditPayment(DataSet);
  finally
    PaymentForm.Free;
  end;
end;

function NewPayment(DataSet: TDataSet): Integer;
begin
  try
    PaymentForm := TPaymentForm.Create(Application);
    Result := PaymentForm.NewPayment(DataSet);
  finally
    PaymentForm.Free;
  end;
end;

{ TPaymentForm }

function TPaymentForm.EditPayment(DataSet: TDataSet): boolean;
begin
  IBAssist.DataSet := DataSet;
   
  PrepareCombo;
  IBAssist.ReadData;

  Result := ShowModal = mrOk;
  if not Result then begin
     ClientsC.Deactivate;
     PayMethodC.Deactivate;
    exit;
  end;
  IBAssist.UpdateData;
  ClientsC.Deactivate;
  PayMethodC.Deactivate;
end;

function TPaymentForm.NewPayment(DataSet: TDataSet): Integer;
var OkClose: boolean;
begin
  Result := -1;
  IBAssist.DataSet := DataSet;
  if IBAssist.DataSet = nil then begin
    IBAssist.DataSet := NewDS;
    NewTr.StartTransaction;
    NewDS.Open;
  end;

  PrepareCombo;

  OkClose := ShowModal = mrOk;
  if not OkClose then begin
    if NewTr.InTransaction then NewTr.Rollback;
    exit;
  end;
  IBAssist.InsertData;
  Result := IBAssist.KeyValue;
  if NewTr.InTransaction then NewTr.Commit;

  ClientsC.Deactivate;
  PayMethodC.Deactivate;
end;

procedure TPaymentForm.PrepareCombo;
begin
  ClientsC.Transaction :=
    TsohoIBTransaction(TsohoIBDataSet(IBAssist.DataSet).Transaction);
  PayMethodC.Transaction :=
    TsohoIBTransaction(TsohoIBDataSet(IBAssist.DataSet).Transaction);
  ClientsC.Activate;
  PayMethodC.Activate;
end;

procedure TPaymentForm.ClientsCBeforeOpen(DataSet: TDataSet);
begin
  TsohoIBDataSet(DataSet).Params[0].AsInteger := ProjectOptions.Id;
end;

procedure TPaymentForm.RegActivate(Sender: TObject);
begin
  NewDS.SelectSQL.LoadFromFile(Reg.PathToSQL + 'Get payments.sql');
end;

procedure TPaymentForm.NewClientBClick(Sender: TObject);
var NewId: Integer;
begin
  NewId := NewClient(nil);
  if NewId = -1 then exit;

  ClientsC.Deactivate;
  ClientsC.Activate;
  ClientsC.ItemId := NewId;
end;

end.
