unit ProjOptionsF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SoCtrls, ComCtrls, SohoBtns, Grids, DBGrids, SoDBGrid,
  FIBDatabase, pFIBDatabase, SoIBClasses, Db, FIBDataSet, pFIBDataSet,
  SoCtmRgs, SoIBRgst, SoListView, OkCancelHelpF, SoEnhTreeView, SoMemTree,
  ActnList;

type
  TProjOptionsForm = class(TForm)
    Pages: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    sohoLabel1: TsohoLabel;
    sohoLabel2: TsohoLabel;
    sohoLabel3: TsohoLabel;
    sohoLabel4: TsohoLabel;
    sohoLabel5: TsohoLabel;
    ProjNameE: TsohoEdit;
    StartDateE: TsohoEdit;
    EmailE: TsohoEdit;
    URLE: TsohoEdit;
    SignatureE: TsohoEdit;
    sohoLabel6: TsohoLabel;
    RegE: TsohoEdit;
    sohoLabel7: TsohoLabel;
    NewsE: TsohoEdit;
    sohoLabel8: TsohoLabel;
    sohoLabel9: TsohoLabel;
    sohoLabel10: TsohoLabel;
    sohoLabel11: TsohoLabel;
    GroupBox1: TGroupBox;
    AddB: TsohoBitBtn;
    DeleteB: TsohoBitBtn;
    SMTPE: TsohoEdit;
    POP3E: TsohoEdit;
    UserNameE: TsohoEdit;
    PasswordE: TsohoEdit;
    OptionsTr: TsohoIBTransaction;
    Reg: TsohoIBSubRegister;
    OkCancelHelpFrame1: TOkCancelHelpFrame;
    ServersTV: TsohoEnhTreeView;
    sohoBitBtn1: TsohoBitBtn;
    sohoBitBtn2: TsohoBitBtn;
    ActionList1: TActionList;
    AddServA: TAction;
    DelServA: TAction;
    AddGrpA: TAction;
    DelGrpA: TAction;
    procedure DelServAUpdate(Sender: TObject);
    procedure AddGrpAUpdate(Sender: TObject);
    procedure DelGrpAUpdate(Sender: TObject);
    procedure AddServAExecute(Sender: TObject);
    procedure DelServAExecute(Sender: TObject);
    procedure AddGrpAExecute(Sender: TObject);
    procedure DelGrpAExecute(Sender: TObject);
    procedure ServersTVEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure ServersTVEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure ServersTVEnter(Sender: TObject);
    procedure ServersTVExit(Sender: TObject);
  private
    { Private declarations }
    procedure Execute;
  public
    { Public declarations }
  end;

var
  ProjOptionsForm: TProjOptionsForm;

procedure ExecuteOptions;

implementation
uses Global, Main, SoIBRtn, SoVCLUtils;

{$R *.DFM}

procedure ExecuteOptions;
begin
  try
    ProjOptionsForm := TProjOptionsForm.Create(Application);
    ProjOptionsForm.Execute;
  finally
    ProjOptionsForm.Free;
  end;
end;

{ TProjOptionsForm }

procedure TProjOptionsForm.Execute;
var I, J: Integer;
    Node, ParentNode: TTreeNode;
begin
  ProjNameE.AsString := ProjectOptions.Name;
  StartDateE.AsDate := ProjectOptions.Start;
  EmailE.AsString := ProjectOptions.Email;
  URLE.AsString := ProjectOptions.Url;
  SignatureE.AsString := ProjectOptions.Signature;
  RegE.AsString := ProjectOptions.RegistrationMessage;
  NewsE.AsString := ProjectOptions.NewsMessage;
  SMTPE.AsString := ProjectOptions.SMTPServer;
  POP3E.AsString := ProjectOptions.POP3Server;
  UserNameE.AsString := ProjectOptions.UserName;
  PasswordE.AsString := ProjectOptions.Password;

  for I := 0 to pred(ProjectOptions.News.Root.List.Count) do begin
    ParentNode := ServersTV.Items.AddChild(ServersTV.Items[0],
      PNewsNode(ProjectOptions.News.Root.List.Nodes[I].Data).Name);
    ParentNode.ImageIndex := 12;
    ParentNode.SelectedIndex := 12;
    for J := 0 to pred(ProjectOptions.News.Root.List.Nodes[I].List.Count) do begin
      Node := ServersTV.Items.AddChild(ParentNode,
         PNewsNode(ProjectOptions.News.Root.List.Nodes[I].List.Nodes[J].Data).Name);
      Node.ImageIndex := 13;
      Node.SelectedIndex := 13;
    end;
  end;

  ServersTV.Items[0].Expand(true);

  if ShowModal = mrOk then begin
    ProjectOptions.Name := ProjNameE.AsString;
    ProjectOptions.Start := StartDateE.AsDate;
    ProjectOptions.Email := EmailE.AsString;
    ProjectOptions.Url := URLE.AsString;
    ProjectOptions.Signature := SignatureE.AsString;
    ProjectOptions.RegistrationMessage := RegE.AsString;
    ProjectOptions.NewsMessage := NewsE.AsString;
    ProjectOptions.SMTPServer := SMTPE.AsString;
    ProjectOptions.POP3Server := POP3E.AsString;
    ProjectOptions.UserName := UserNameE.AsString;
    ProjectOptions.Password := PasswordE.AsString;
  end;
end;

procedure TProjOptionsForm.DelServAUpdate(Sender: TObject);
begin
  DelServA.Enabled := (ServersTV.Selected <> nil) and
    (ServersTV.Selected.Level = 1);
end;

procedure TProjOptionsForm.AddGrpAUpdate(Sender: TObject);
begin
  AddGrpA.Enabled := (ServersTV.Selected <> nil) and
    (ServersTV.Selected.Level >= 1);
end;

procedure TProjOptionsForm.DelGrpAUpdate(Sender: TObject);
begin
  DelGrpA.Enabled := (ServersTV.Selected <> nil) and
    (ServersTV.Selected.Level > 1);
end;

procedure TProjOptionsForm.AddServAExecute(Sender: TObject);
var Id: Integer;
    ItemName: string;
    Node: TTreeNode;
begin
  if not MainForm.ServersGuide.Execute(false, true, true) then exit;
  Id := MainForm.ServersGuide.ItemId;
  if ProjectOptions.ServerIndexById(Id) <> -1 then exit;
  ItemName := GetSQLResult(Reg.PathToSQL + 'Get NewsServer Name.sql',
       MainForm.MainDB, nil, [IntToStr(Id)]);
  {ProjectOptions.NewsServers.AddObject(ItemName, pointer(Id));
  Item := ServersLV.Items.Add;
  Item.Caption := ItemName;}
  Node := ServersTV.Items.AddChild(ServersTV.Items[0], ItemName);
  Node.ImageIndex := 12;
  Node.SelectedIndex := 12;
  ProjectOptions.AddNewsServer(-1, Id, ItemName, '', '', '');
end;

procedure TProjOptionsForm.DelServAExecute(Sender: TObject);
begin
  if not YesNoMsg('Are you sure you want to delete NewsServer: '+
    ServersTV.Selected.Text + '?') then exit;
  ProjectOptions.DeleteNewsServer(ServersTV.Selected.Index);
  ServersTV.Selected.Delete;
end;

procedure TProjOptionsForm.AddGrpAExecute(Sender: TObject);
var Newsgroup: string;
    ParentNode: TTreeNode;
    Node: TTreeNode;
begin
  if not InputQuery('Add newsgroup', 'Name', Newsgroup) then exit;
  if ServersTV.Selected.Level = 1 then ParentNode := ServersTV.Selected
  else ParentNode := ServersTV.Selected.Parent;
  Node := ServersTV.Items.AddChild(ParentNode, Newsgroup);
  Node.ImageIndex := 13;
  Node.SelectedIndex := 13;
  ProjectOptions.AddNewsGroup(ParentNode.Index, Newsgroup);
end;

procedure TProjOptionsForm.DelGrpAExecute(Sender: TObject);
begin
  if not YesNoMsg('Are you sure you want to delete Newsgroup: '+
    ServersTV.Selected.Text + '?') then exit;
  ProjectOptions.DeleteNewsGroup(ServersTV.Selected.Parent.Index,
    ServersTV.Selected.Index);
  ServersTV.Selected.Delete;
end;

procedure TProjOptionsForm.ServersTVEditing(Sender: TObject;
  Node: TTreeNode; var AllowEdit: Boolean);
begin
  AllowEdit := Node.Level > 1;
end;

procedure TProjOptionsForm.ServersTVEdited(Sender: TObject;
  Node: TTreeNode; var S: String);
begin
  PNewsNode(ProjectOptions.News.Root.List.Nodes[Node.Parent.Index].List.Nodes[Node.Index].Data).Name := S;
end;

procedure TProjOptionsForm.ServersTVEnter(Sender: TObject);
begin
  OkCancelHelpFrame1.OkB.Default := false;
end;

procedure TProjOptionsForm.ServersTVExit(Sender: TObject);
begin
  OkCancelHelpFrame1.OkB.Default := true;
end;

end.
