unit UserF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OkCancelHelpF, StdCtrls, SoCtrls, SoCtmRgs, SoIBRgst, SoCtmDBAssist,
  SohoIBAssist, DB, FIBDataSet, pFIBDataSet, SoIBClasses, FIBDatabase,
  pFIBDatabase;

type
  TUserForm = class(TForm)
    sohoLabel1: TsohoLabel;
    sohoLabel2: TsohoLabel;
    sohoLabel3: TsohoLabel;
    sohoLabel5: TsohoLabel;
    sohoLabel4: TsohoLabel;
    sohoLabel6: TsohoLabel;
    sohoLabel7: TsohoLabel;
    sohoLabel8: TsohoLabel;
    sohoLabel9: TsohoLabel;
    sohoLabel10: TsohoLabel;
    sohoLabel11: TsohoLabel;
    sohoLabel12: TsohoLabel;
    sohoLabel13: TsohoLabel;
    FirstE: TsohoEdit;
    SecondE: TsohoEdit;
    CompanyE: TsohoEdit;
    AddressE: TsohoEdit;
    CityE: TsohoEdit;
    StateE: TsohoEdit;
    ZIPE: TsohoEdit;
    MailE: TsohoEdit;
    PhoneE: TsohoEdit;
    CountryC: TsohoComboBox;
    OkCancelHelpFrame1: TOkCancelHelpFrame;
    IBAssist: TsohoIBAssist;
    Reg: TsohoIBSubRegister;
    NewTr: TsohoIBTransaction;
    NewDS: TsohoIBDataSet;
    procedure CountryCExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegActivate(Sender: TObject);
  private
    { Private declarations }
    function EditUser(DataSet: TDataSet): boolean;
    function NewUser(DataSet: TDataSet): Integer;
  public
    { Public declarations }
  end;

var
  UserForm: TUserForm;

function EditUser(DataSet: TDataSet): boolean;
function NewUser(DataSet: TDataSet): Integer;

implementation
uses SoVCLUtils, SoAppUtils, Main;

{$R *.DFM}

function EditUser(DataSet: TDataSet): boolean;
begin
  try
    UserForm := TUserForm.Create(Application);
    Result := UserForm.EditUser(DataSet);
  finally
    UserForm.Free;
  end;
end;

function NewUser(DataSet: TDataSet): Integer;
begin
  try
    UserForm := TUserForm.Create(Application);
    Result := UserForm.NewUser(DataSet);
  finally
    UserForm.Free;
  end;
end;

procedure TUserForm.CountryCExit(Sender: TObject);
begin
  if CountryC.Items.IndexOf(CountryC.Text) = -1 then
    CountryC.Items.Add(CountryC.Text);
end;

procedure TUserForm.FormCreate(Sender: TObject);
begin
  if FileExists(GetRunDir + 'countries.lst') then
    CountryC.Items.LoadFromFile(GetRunDir + 'countries.lst');
end;

procedure TUserForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CountryC.Items.SaveToFile(GetRunDir + 'countries.lst');
end;

function TUserForm.EditUser(DataSet: TDataSet): boolean;
begin
  IBAssist.DataSet := DataSet;
  IBAssist.ReadData;
  Result := ShowModal = mrOk;
  if not Result then exit;
  IBAssist.UpdateData;
end;

function TUserForm.NewUser(DataSet: TDataSet): Integer;
var OkClose: boolean;
begin
  Result := -1;
  IBAssist.DataSet := DataSet;
  if IBAssist.DataSet = nil then begin
    IBAssist.DataSet := NewDS;
    NewTr.StartTransaction;
    NewDS.Open;
  end;
  OkClose := ShowModal = mrOk;
  if not OkClose then begin
    if NewTr.InTransaction then NewTr.Rollback;
    exit;
  end;
  IBAssist.InsertData;
  Result := IBAssist.KeyValue;
  if NewTr.InTransaction then NewTr.Commit;
end;

procedure TUserForm.RegActivate(Sender: TObject);
begin
  NewDS.SelectSQL.LoadFromFile(Reg.PathToSQL + 'Get users.sql');
end;

end.
