@echo off
@echo {*******************************************************}
@echo {                                                       }
@echo {           Delphi Visual Component Library             }
@echo {                                                       }
@echo {           Copyright (c) 2000 Second Dream             }
@echo {                    SohoIBLib Pro                      }
@echo {                                                       }
@echo {*******************************************************}
@echo .
@echo .
@echo            SohoIBLib Pro for Delphi 5 Installation 
@echo .
@echo .
@echo {*******************************************************}
@echo {         Phase 1 - Special variables setting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * At first, you must set the special variables:       *
rem   * 1. DELPHIBIN - path to your Delphi bin directory    *
rem   * 2. RBPLDIR   - path to directory for run-time BPL   *
rem   *    files (Windows system directory is recommended)  *
rem   * 3. RBPLDIR   - path to directory for design-time    *
rem   *    BPL (Default value is recommended)               *
rem   *******************************************************

@set DELPHIROOT=F:\Delphi\Delphi5
@set DELPHIBIN=%DELPHIROOT%\BIN
@set RBPLDIR=D:\winnt\System32
@set DBPLDIR=%DELPHIROOT%\Projects\BPL
@set FIBPLUSDIR=G:\Delphi.Add\FP
@set SOHOLIBDIR=d:\borland\vcl5\soholib

@echo .
@echo .
@echo {*******************************************************}
@echo {        Phase 2 - Superfluous files deleting           }
@echo {*******************************************************}

rem   *******************************************************
rem   * Now, we delete superfluous files from the SohoLib   *
rem   * directory and from design-time packages directory   *
rem   *******************************************************

@if exist *.~?? del *.~?? >nul
@if exist *.dpl del *.dpl >nul
@if exist *.bpl del *.bpl >nul
@if exist *.dcp del *.dcp >nul
@if exist *.dcu del *.dcu >nul
@if exist %DBPLDIR%\DsoIB5.bpl del %DBPLDIR%\DsoIB5.bpl >nul
@if exist %DBPLDIR%\DsoIB5.dcp del %DBPLDIR%\DsoIB5.dcp >nul

@echo .
@echo .
@echo {*******************************************************}
@echo {     Phase 3 - Design-time packages compilation        }
@echo {*******************************************************}

@%DELPHIBIN%\dcc32.exe DsoIB5.dpk -B -U%DBPLDIR%;%SOHOLIBDIR%;%FIBPLUSDIR% >>ErrorLog.Log
@if ErrorLevel=1 goto DTCommonError
@echo DsoIB5.dpk was compiled successfully

@if exist %DBPLDIR%\DsoIB5.bpl del %DBPLDIR%\DsoIB5.bpl >nul
@if exist %DBPLDIR%\DsoIB5.dcp del %DBPLDIR%\DsoIB5.dcp >nul

@if exist *.bpl move *.bpl %DBPLDIR% >nul
@if exist *.dcp move *.dcp %DBPLDIR% >nul

goto End

:DTCommonError
@echo DsoIB5.dpk was compiled with errors!
@pause
goto End 

:End