{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov,              }
{                    Igor Chernyshov                    }
{                                                       }
{            Devrace SohoIBLib Pro Components           }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: sohoiblib@devrace.com             }
{                                                       }
{*******************************************************}
{
    TsohoIBComboBox -   
   .      
}
unit SoIbComb;

{$I SOHOIBLIB.INC}

interface

uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
     Forms, StdCtrls, Menus, SoUnit, SoTools, DB, SoCtmCmb, SoIBClasses;

type

  {         .  
      (SQLFile),  ,   
         (TextField),     
     (KeyField),         IdItems.
        TableName -    
        SQLFile   .   
         ItemId
  }
  TsohoIBComboBox = class(TsohoCustomDBComboBox)
  private
    { Private declarations }
    FDataBase: TsohoIBDataBase;
    FTransaction: TsohoIBTransaction;
  protected
    { Protected declarations }
    function  ActivateSelection (SQLText : TStringList) : TDataSet;override;
    procedure DoInsertSQL (SQLText : TStringList);override;
    procedure PrepareList;override;
    procedure GenerateInsertSQL(Query: TStringList); override;
    procedure GenerateSelectSQL(Query: TStringList); override;
  public
    constructor Create(aOwner : TComponent);override;
  published
    {    }
    property DataBase: TsohoIBDataBase read FDataBase write FDataBase;
    property Transaction : TsohoIBTransaction read FTransaction write FTransaction;
  end;

implementation
uses SoAppUtils, SoIbRgst, SoIBUtil, SoVCLUtils;

constructor TsohoIBComboBox.Create(aOwner : TComponent);
begin
  inherited Create(aOwner);
  FDataBase := nil;
  FTransaction := nil;
end;

function  TsohoIBComboBox.ActivateSelection (SQLText : TStringList) : TDataSet;
var Tmp : TsohoIBDataSet;
begin
  PushCursor(crHourGlass);
  try
    Tmp := TsohoIBDataSet.Create(self);
    Tmp.SelectSQL.Assign(SQLText);
    Tmp.DataBase := FDataBase;
    Tmp.Transaction := FTransaction;
    TransactionStart(FTransaction);
    DoBeforeOpen(Tmp);
    Tmp.Prepare;
    Tmp.Open;
    Result := Tmp;
    RestoreCursor;
  except
    on E: Exception do begin
      RestoreCursor;
      ErrorMsg(Name+': '+E.Message);
      Result := nil;
    end;
  end;
end;

procedure TsohoIBComboBox.DoInsertSQL (SQLText : TStringList);
var Tmp : TsohoIBSQL;
begin
  PushCursor(crHourGlass);
  try
    Tmp := TsohoIBSQL.Create(self);
    Tmp.DataBase := FDataBase;
    Tmp.Transaction := FTransaction;
    with Tmp do begin
      SQL.Assign(SQLText);
      TransactionStart(FTransaction);
      Prepare;
      ExecSQL;
      Close;
    end;
    RestoreCursor;
    FTransaction.CommitRetaining;
  except
    on E: Exception do begin
      TransactionRollback(FTransaction);
      RestoreCursor;
      ErrorMsg(Name+': '+E.Message);
    end;
  end;
end;

procedure TsohoIBComboBox.PrepareList;
begin
  if Assigned(SingleIBRegister) then begin
    if not Assigned(FDataBase) then FDataBase := SingleIBRegister.DataBase;
    if not Assigned(FTransaction) then FTransaction := SingleIBRegister.Transaction;
  end;
  inherited PrepareList;
end;

procedure TsohoIBComboBox.GenerateInsertSQL(Query: TStringList);
begin
  Query.Add('insert into ' + FormatIdentifier(DataBase.SQLDialect, TableName) +
    ' (' + FormatIdentifier(DataBase.SQLDialect, KeyField) +
    ', ' + FormatIdentifier(DataBase.SQLDialect, TextField) + ')');
end;

procedure TsohoIBComboBox.GenerateSelectSQL(Query: TStringList);
begin
  Query.Add('select ' + FormatIdentifier(DataBase.SQLDialect, KeyField) +
    ', ' + FormatIdentifier(DataBase.SQLDialect, TextField) + ' from ' +
    FormatIdentifier(DataBase.SQLDialect, TableName));
end;

end.

