{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{              Written by Igor Chernyshov               }
{                                                       }
{            Devrace SohoIBLib Pro Components           }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: sohoiblib@devrace.com             }
{                                                       }
{*******************************************************}
unit SoIBDBGridAddon;

{$I SOHOIBLIB.INC}
interface

uses Windows, SysUtils, Classes, SoCtmDBGridAddon, SoIBClasses;

type
  {      ,   
    (TsohoDBGrid),      AllowSorting = True,
            
        .
       ORDER BY  DataSet ( UseOrderby = true)
       Sort  FIBC (UseOrderby = False).
     :      ,  Dataset
       TFIBCustomDataSet.    
    FreeIBComponents,   TsohoDBGridAddon -  ,
     Dataset   TQuery.
           Dataset TTable -    
     .  TTable    .  -
     -    ,   -   }
  TsohoIBDBGridAddon = class(TsohoCustomDBGridAddon)
  private
    { Private declarations }
    FUseOrderBy : Boolean;
  protected
    function  ValidDataSet : boolean; override;
    procedure ChangeOrderBy (FieldNo : integer; const FieldName : string; AscSortOrder : Boolean); override;
    procedure FullRefreshDataSetFilter; override;
    procedure NoSort; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    {        }
    property  AllowSorting;
    {       }
    property AllowFiltering;
    {      (TField.FieldName)  
     (TField.FieldNo).     FieldNames.  , 
    select    ,       .
    ,    :
    ---
    SELECT MAIN_PROV.NAME, SPR_PCH.NAME, MEROPR_GRP.NAME
    FROM   MAIN_PROV, SPR_PCH, MEROPR_GRP
    WHERE  MAIN_PROV.KOD_PCH     = SPR_PCH.ID AND
           MAIN_PROV.IDMEROPRGRP = MEROPR_GRP.ID
    ---
          ,  SortByFieldNo = true
      FieldNames       :
    MAIN_PROV.NAME
    SPR_PCH.NAME
    MEROPR_GRP.NAME
    }
    property  SortByFieldNo;
    {    .   . SortByFieldNo}
    property  FieldNames;
    {   ORDER BY  DataSet  UseOrderby = true)
       Sort  FIBC (UseOrderby = False).}
    property  UseOrderBy : Boolean read FUseOrderBy write FUseOrderBy default True;
    property BeforeOperation;
    {        }
    property AfterOperation;
    {         }
  end;

implementation
uses SoDBRtn, StrUtil;

//------------------------------------------------------------------------------
// PROTECTED
//------------------------------------------------------------------------------
procedure TsohoIBDBGridAddon.FullRefreshDataSetFilter;
begin
  //  FIBPlus   ,   BDE
  //   .
  DoBeforeOperation;
  RefreshDataSetFilter(Grid.DataSource.DataSet);
  DoAfterOperation;
end;

function  TsohoIBDBGridAddon.ValidDataSet : boolean;
begin
  Result := (Grid.DataSource.DataSet is TsohoIBDataSet);
end;

procedure TsohoIBDBGridAddon.ChangeOrderBy(FieldNo : integer; const FieldName : string; AscSortOrder : Boolean);
Var
  i : integer;
  s : string;
begin
  if FUseOrderBy then begin
    Grid.DataSource.DataSet.Close;
    s := (Grid.DataSource.DataSet as TsohoIBDataSet).SelectSQL.Text;
    i := pos('ORDER BY', AnsiUpperCase(S));
    if i <> 0 then S := Copy(S, 1, i - 1);
    S := S + ' ORDER BY ' +
      FormatIdentifier((Grid.DataSource.DataSet as TsohoIBDataSet).Database.SQLDialect, FieldName);
    if not AscSortOrder then S := S + ' DESC ';
    (Grid.DataSource.DataSet as TsohoIBDataSet).SelectSQL.Text := S;
    Grid.DataSource.DataSet.Open;
  end
  else
    (Grid.DataSource.DataSet as TsohoIBDataSet).DoSort([FieldName], [AscSortOrder]);
end;

//------------------------------------------------------------------------------
// PUBLIC
//------------------------------------------------------------------------------
constructor TsohoIBDBGridAddon.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FUseOrderBy := True;
end;

procedure TsohoIBDBGridAddon.NoSort;
var s: string;
    i: LongInt;
begin
  inherited;
  if FUseOrderBy then begin
    Grid.DataSource.DataSet.Close;
    s := (Grid.DataSource.DataSet as TsohoIBDataSet).SelectSQL.Text;
    i := pos('ORDER BY', AnsiUpperCase(S));
    if i <> 0 then S := Copy(S, 1, i-1);
    (Grid.DataSource.DataSet as TsohoIBDataSet).SelectSQL.Text := S;
    Grid.DataSource.DataSet.Open;
  end  
  else RefreshDataSet(Grid.DataSource.DataSet);
end;

end.
