{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{            Devrace SohoIBLib Pro Components           }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: sohoiblib@devrace.com             }
{                                                       }
{*******************************************************}
{
       
     SoUnit,    
   IB DataBase.
       uses,    
  SetDataBase   SoIBUtil
}
unit SoIbIdent;

{$I SOHOIBLIB.INC}

interface

implementation
uses SysUtils, SoUnit, SoIBUtil, SoIBClasses, SoVCLUtils, SoIBCns, FIB;

type

  EIBError = EFIBError;

var
  GetDS : TsohoIBSQL;
  GetTr : TsohoIBTransaction;

function  GetIBNewId (const GeneratorName : string): LongInt;
begin
  Result := 0;
  if not Assigned(MetaDB) then begin
    ErrorMsg(sohoIBMetaDBUnknown);
    exit;
  end;

  if not Assigned(GetTr.DefaultDatabase) then GetTr.DefaultDatabase := MetaDB;

  NewTransactionStart(GetTr);
  with GetDS do begin
    Database := MetaDB;
    // Transaction := GetTr;
    SQL.Text := 'select GEN_ID(' +
      FormatIdentifier(MetaDB.SQLDialect, GeneratorName) + ', 1) from RDB$DATABASE';
    try
      // statements to try
      ExecSQL;
      {$IFNDEF Delphi5}
      Result := Fields[0].AsInteger;
      {$ELSE}
      if MetaDB.SQLDialect = 3 then
        Result := Fields[0].AsInt64
      else
        Result := Fields[0].AsInteger;
      {$ENDIF}
      TransactionCommit(GetTr);
    except
      on E: EIBError do begin
        TransactionRollback(GetTr);
        ErrorMsg(E.Message);
        Exit;
      end;
    end;    // try/except
  end;    // with
end;

procedure SetIBNewId (const GeneratorName : string; Value: LongInt);
begin
  if not Assigned(MetaDB) then begin
    ErrorMsg(sohoIBMetaDBUnknown);
    exit;
  end;
  // SetGeneratorValue(FormatIdentifier(MetaDB.SQLDialect, GeneratorName), Value);
  with GetDS do begin
    Database := MetaDB;
    SQL.Text := 'set generator ' +
      FormatIdentifier(MetaDB.SQLDialect, GeneratorName) + ' to ' + IntToStr(Value);
    try
      ExecSQL;
      TransactionCommit(GetTr);
    except
      on E: EIBError do begin
        TransactionRollback(GetTr);
        ErrorMsg(E.Message);
        Exit;
      end;
    end;    // try/except
  end;    // with
end;

initialization
  GetDS := TsohoIBSQL.Create(nil);
  GetTr := TsohoIBTransaction.Create(nil);
  GetDS.Transaction := GetTr;
  OverrideNewIdRoutine(GetIBNewId, SetIBNewId);
finalization
  GetDS.Free;
  GetTr.Free;
end.
