{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{            Devrace SohoIBLib Pro Components           }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: sohoiblib@devrace.com             }
{                                                       }
{*******************************************************}
unit SoIBLgnDlg;

{$I SOHOIBLIB.INC}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SoCtrls, ComCtrls, SohoBtns, SoTools, SoIBClasses, ExtCtrls;

type
  TsohoIbLoginDlg = class(TForm)
    Animate1: TAnimate;
    UserL: TsohoLabel;
    PasswordL: TsohoLabel;
    UserNameE: TsohoEdit;
    PasswordE: TsohoEdit;
    ConnectB: TsohoBitBtn;
    DBNameL: TsohoLabel;
    sohoEnterTab1: TsohoEnterTab;
    Shape1: TShape;
    procedure ConnectBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    function ShowIBLoginDialog (var UserName, Password: string; DB: TsohoIBDataBase): boolean;
  public
    { Public declarations }
    FDB: TsohoIBDataBase;
  end;

var
  sohoIbLoginDlg: TsohoIbLoginDlg;

function ShowIBLoginDialog (var UserName, Password: string; DB: TsohoIBDataBase): boolean;

implementation
uses SoVCLUtils, SoIBCns;

{$R *.DFM}

function ShowIBLoginDialog (var UserName, Password: string; DB: TsohoIBDataBase): boolean;
begin
  try
    sohoIbLoginDlg := TsohoIbLoginDlg.Create(Application);
    Result := sohoIbLoginDlg.ShowIBLoginDialog(UserName, Password, DB);
  finally
    sohoIbLoginDlg.Free;
  end;
end;

function TsohoIbLoginDlg.ShowIBLoginDialog (var UserName, Password: string; DB: TsohoIBDataBase): boolean;
begin
  Result := false;
  UserNameE.AsString := UserName;
  PasswordE.AsString := Password;
  FDB := DB;
  if not Assigned(DB) then exit;
  DBNameL.Caption := FDB.DBName;
  ShowModal;
  Result := DB.Connected;
  if not Result then exit;
  UserName := UserNameE.AsString;
  Password := PasswordE.AsString;
end;

procedure TsohoIbLoginDlg.ConnectBClick(Sender: TObject);
begin
  Animate1.Active := true;
  FDB.UserName := UserNameE.AsString;
  FDB.Password := PasswordE.AsString;
  try
    FDB.Open;
    Animate1.Active := false;
    ModalResult := mrOk;
  except
    on E: Exception do begin
      Animate1.Active := false;
      ErrorMsg('      .     !');
    end;
  end;
end;

procedure TsohoIbLoginDlg.FormCreate(Sender: TObject);
begin
  Caption := sohoIBConnectDialogTitle;
  UserL.Caption := sohoIBConnectDialogUser;
  PasswordL.Caption := sohoIBConnectDialogPassword;
  ConnectB.Caption := sohoIBConnectDialogConnect;
end;

end.
