{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{              Written by Serg Vostrikov,               }
{                   Igor Chernyshov                     }
{                                                       }
{            Devrace SohoIBLib Pro Components           }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: sohoiblib@devrace.com             }
{                                                       }
{*******************************************************}
unit SoIBReg;

{.$DEFINE INSTALL_ALERTER}
{.$DEFINE INSTALL_SERVICES}
{$I SOHOIBLIB.INC}

interface

procedure Register;

implementation
uses SysUtils, Classes, SoIBTreeView, SoIBRec,  SoIBFolder,
     SoIBRgst, SoIBTVCont, SoIBGuide, SoIBComb, SoIBClasses,
     SoIBSQLMonitor, SoIBGrant{$IFDEF INSTALL_ALERTER}, SoIBAlerter{$ENDIF}, SoIBDBGridAddon,
     SoIBPrp, SohoIBAssist, SohoIBAssistProps, SoIBManager,
     {$IFDEF Delphi6}DesignEditors, DesignIntf{$ELSE}DsgnIntf{$ENDIF},
     {$IFDEF INSTALL_SERVICES}SoIBServices, SoIBInstall, {$ENDIF}SoIBQSearch;

{$R SOIBREG.DCR}
procedure Register;
begin
  RegisterComponents ('SOHO-IB', [
           TsohoIBDatabase,
           TsohoIBTransaction,
           TsohoIBDataSet,
           TsohoIBSQL,
           TsohoIBTreeView,
           TsohoIBRecordForm,
           TsohoIBFolder,
           TsohoIBRegister,
           TsohoIBSubRegister,
           TsohoIBTVContainer,
           TsohoIBGuide,
           TsohoIBComboBox,
           TsohoIBSQLMonitor,
           TsohoIBQuickSearch,
{$IFDEF INSTALL_ALERTER}
           TsohoIBAlerter,
{$ENDIF}
           TsohoIBDBGridAddon,
           TsohoIBAssist,
           TsohoIBManager,
           TsohoIBGrantManager
{$IFDEF INSTALL_SERVICES},
           TsohoIBServerProperties,
           TsohoIBConfigService,
           TsohoIBLicensingService,
           TsohoIBLogService,
           TsohoIBStatisticalService,
           TsohoIBBackupService,
           TsohoIBRestoreService,
           TsohoIBValidationService,
           TsohoIBSecurityService,
           TsohoIBInstall,
           TsohoIBUninstall
{$ENDIF}
  ]);
  // TSohoIBAssist
  RegisterComponentEditor(TsohoIBAssist, TsohoFormIBAssistEditor);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBAssist, 'KeyField'     , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBAssist, 'TableName'    , TsohoIBTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBAssist, 'GeneratorName', TsohoIBGeneratorNameProperty);

  // TSohoIBFolder
  RegisterPropertyEditor(TypeInfo(string), TsohoIBFolder, 'TableName'    , TsohoIBTableNameProperty);

  // TSohoIBTreeView
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'GroupsTable' , TsohoIBTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'ItemsTable'  , TsohoIBTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'GroupPreffix', TsohoIBGeneratorNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'ItemsPreffix', TsohoIBGeneratorNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'HashField'   , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'KeyField'    , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'OrderField'  , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'NameGroupID' , TsohoFormIBGroupFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TsohoIBTreeView,'NameParentID', TsohoFormIBGroupFieldsProperty);

  // TSohoIBTVContainer
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'GroupsTable' , TsohoIBTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'ItemsTable'  , TsohoIBTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'GroupPreffix', TsohoIBGeneratorNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'ItemsPreffix', TsohoIBGeneratorNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'HashField'   , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'KeyField'    , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'OrderField'  , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'NameGroupID' , TsohoFormIBGroupFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBTVContainer,'NameParentID', TsohoFormIBGroupFieldsProperty);

  // TSohoIBGuide
  RegisterPropertyEditor(TypeInfo(string), TSohoIBGuide,'FolderTable' , TsohoIBTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBGuide,'KeyField'    , TsohoFormIBFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), TSohoIBGuide,'ItemsPreffix', TsohoIBGeneratorNameProperty);
end;

end.
