{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{               Written by Serg Vostrikov               }
{                                                       }
{            Devrace SohoIBLib Pro Components           }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: sohoiblib@devrace.com             }
{                                                       }
{*******************************************************}
unit SoIBRtn;

{$I SOHOIBLIB.INC}

interface
uses Classes, SoTools, SysUtils, SoIBClasses;

{      . SQLFile -    
  SQL-, aDataBaseName -    , SQLParams -  
  ,      .    
    @1,@2   .   ,   
  RoutinesQuiet = true,   -  . 
     ,       .
  ,     , , ,    
   : "@1"}
function GetSQLResult(const SQLfile: TFileName; aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): string;

{       TQuery. SQLFile -    
  SQL-, aDataBaseName -    , SQLParams -  
  ,      .    
    @1,@2   .   ,   
  RoutinesQuiet = true,   -  . 
     ,       .
  ,     , , ,    
   : "@1"}
function GetQuery(const SQLfile: TFileName; aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): TsohoIBDataSet;

{   GetSQLResult,   ,     }
function GetCheckSQLResult(const SQLfile: TFileName;  aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string;
         var Null: boolean): string;

{     .      
  GetSQLResult }
function ExecuteSQL(const SQLfile: TFileName;  aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): boolean;

{  ExecuteSQL,   ,        }
function ExecuteSQLText(const SQLText: string; aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): boolean;

{   ExecuteSQL.    , ExecuteSQL  
    Insert, Update  Delete,     
      Select }
function OpenQueryWithParams (Query : TsohoIBDataSet; const SQLFile : string;
  SQLParams: array of string) : boolean;

{ ,  aa    }
function PutParameteres(SQL: TStrings; Params: array of string): boolean;
{       SQL- }
{
function GetFieldSQLSumm(const TableName, FieldName: string;
         aDataBase: TsohoIBDataBase; aTransaction : TsohoIBTransaction): Double;
}

function BoolToIB (Value: boolean) : integer;
function BoolToIBStr (Value: boolean) : string;

const
  {      ,   
       SQL-,   
     .         
     }
  NillParams: array[0..0] of string = ('NILLPARAMS');

var
  {    true     , 
             }
  RoutinesQuiet       : boolean;

  {  true,          }
  ShowSQLBeforeExecute: boolean;

implementation
uses SoAppUtils, SoDate, SoIBRgst, Windows, SoDBCns, SoIBUtil, DB,
     SoVClUtils, SoStrUtils;

function CreateTransaction (aDataBase : TsohoIBDataBase) : TsohoIBTransaction;
begin
  Result := TsohoIBTransaction.Create(nil);
  Result.DefaultDatabase := aDataBase;
end;

function PutParameteres(SQL: TStrings; Params: array of string): boolean;
var index: Longint;
  CurInd: Longint;
  CurPos: Longint;
  Tmp   : string;

  function FindParams(var IndexOfString, ParamPos: Longint): boolean;
  var StrIndex: Integer;
  begin
    Result := True;
    for StrIndex := 0 to pred(SQL.Count) do begin
      IndexOfString := StrIndex;
      ParamPos := Pos('@' + IntToStr(index + 1), SQL[StrIndex]);
      if ParamPos <> 0 then exit;
    end;
    Result := False;
  end;

  procedure SetSpecialParams;
  const
    SpecParams: array[1..4] of string = (
      'MDFDATE', 'MDFTIME', 'IDMDFAUTH', 'PROTECT'
      );
  var ParamPos,
    SpecIndex: Integer;
    StrIndex : Integer;
    Value    : string;
  begin
    for StrIndex := 0 to pred(SQL.Count) do
      for SpecIndex := 1 to 4 do begin
        Tmp := AnsiUpperCase(SQL[StrIndex]);
        ParamPos := Pos('@' + SpecParams[SpecIndex], Tmp);
        if ParamPos <> 0 then begin
          Tmp := SQL[StrIndex];
          case SpecIndex of
            1: Value := DateToSQLDate(Date);
            2: Value := SingleQuotes(TimeToStr(SysUtils.Time));
            3: if SingleIBRegister <> nil then
              Value := IntToStr(SingleIBRegister.UserId)
            else Value := '0';
            4: if SingleIBRegister <> nil then
              Value := IntToStr(SingleIBRegister.DataLevel)
            else Value := '0';
          end;
          Tmp := Copy(Tmp, 1, ParamPos - 1) + Value + Copy(Tmp, ParamPos +
            Length('@' + SpecParams[SpecIndex]), Length(Tmp));
          SQL[StrIndex] := Tmp;
        end;
      end;
  end;
begin
  Result := False;
  if Params[Low(Params)] = NillParams[0] then begin
    Result := True;
    exit;
  end;
  for index := Low(Params) to High(Params) do
    if not FindParams(CurInd, CurPos) then exit
    else begin
      Tmp := SQL[CurInd];
      Tmp := Copy(Tmp, 1, CurPos - 1) + Params[index] + Copy(Tmp, CurPos +
        Length('@' + IntToStr(index + 1)), Length(Tmp));
      SQL[CurInd] := Tmp;
    end;
  SetSpecialParams; {16/10/98}
  if ShowSQLBeforeExecute then begin
    SQL.SaveToFile(GetPathToTemp + 'CURSQL.SQL');
    WinExec('notepad.exe CURSQL.SQL', SW_SHOWNORMAL);
  end;
  Result := True;
end;

function GetCheckSQLResult(const SQLfile: TFileName;  aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string;
         var Null: boolean): string;
var TmpQ: TsohoIBDataSet;
    TmpTr: TsohoIBTransaction;
begin
  Result := '';
  TmpTr := nil;
  TmpQ := TsohoIBDataSet.Create(nil);
  try
    with TmpQ, SelectSQL do begin
      DataBase := aDataBase;
      if Assigned(aTransaction) then Transaction := aTransaction
      else begin
        TmpTr := CreateTransaction(aDatabase);
        Transaction := TmpTr;
      end;
      LoadFromFile(SQLfile);
      if (not PutParameteres(TStringList(SelectSQL), SQLParams)) and
        (not RoutinesQuiet) then begin
        ErrorMsg(Format(sohoBDERtnTooManyParams,[SQLfile]));
      end
      else
        try
          PushCursor(crHourGlass);
          TransactionStart(TsohoIBTransaction(Transaction));
          Open;
          Null := Fields[0].IsNull;
          Result := TStringField(Fields[0]).AsString;
          if Assigned(TmpTr) then TransactionCommit(TsohoIBTransaction(Transaction));
        except
          on E: Exception do begin
              if Assigned(TmpTr) then TransactionRollback(TsohoIBTransaction(Transaction));
              TStringList(SelectSQL).SaveToFile(GetPathToLocalTemp+'error.sql');
              ErrorMsg(Format(sohoBDERtnOpenError, [SQLfile, E.message]));
          end;
        end;
    end;
  finally
    TmpQ.Free;
    if Assigned(TmpTr) then TmpTr.Free;
    RestoreCursor;
  end;
end;

function GetSQLResult(const SQLfile: TFileName; aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): string;
var Null: boolean;
begin
  Result := GetCheckSQLResult(SQLfile, aDataBase, aTransaction, SQLParams, Null);
end;

function GetQuery(const SQLfile: TFileName; aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): TsohoIBDataSet;
begin
  Result := TsohoIBDataSet.Create(nil);
  with Result, SelectSQL do begin
    DataBase := aDataBase;
    LoadFromFile(SQLfile);
    if (not PutParameteres(TStringList(SelectSQL), SQLParams)) and
      (not RoutinesQuiet) then begin
      ErrorMsg(Format(sohoBDERtnTooManyParams,[SQLfile]));
    end
    else
      try
        Transaction := aTransaction;
        PushCursor(crHourGlass);
        TransactionStart(TsohoIBTransaction(Transaction));
        Open;
      except
        on E: Exception do begin
            TStringList(SelectSQL).SaveToFile(GetPathToLocalTemp+'error.sql');
            RestoreCursor;
            ErrorMsg(Format(sohoBDERtnOpenError, [SQLfile, E.message]));
            Result.Free;
            Result := nil;
          end
      end;
  end;
  RestoreCursor;
end;

function OpenQueryWithParams (Query : TsohoIBDataSet; const SQLFile : string;
  SQLParams: array of string) : boolean;
begin
  Result := false;
  with Query, SelectSQL do begin
    Close;
    LoadFromFile(SQLfile);
    if (not PutParameteres(TStringList(SelectSQL), SQLParams)) and
      (not RoutinesQuiet) then begin
      ErrorMsg(Format(sohoBDERtnTooManyParams,[SQLfile]));
    end
    else
      try
        PushCursor(crHourGlass);
        Open;
        Result := true;
      except
        on E: Exception do begin
            TStringList(SelectSQL).SaveToFile(GetPathToLocalTemp+'error.sql');
            RestoreCursor;
            ErrorMsg(Format(sohoBDERtnOpenError, [SQLfile, E.message]));
          end
      end;
  end;
  RestoreCursor;
end;

function ExecuteSQL(const SQLfile: TFileName;  aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): boolean;
var TmpQ: TsohoIBSQL;
    TmpTr: TsohoIBTransaction;
begin
  Result := False;
  TmpTr := nil;
  TmpQ := TsohoIBSQL.Create(nil);
  try
    with TmpQ, SQL do begin
      ParamCheck := false;
      DataBase := aDataBase;
      LoadFromFile(SQLfile);
      if (not PutParameteres(TStringList(SQL), SQLParams)) and
        (not RoutinesQuiet) then begin
        ErrorMsg(Format(sohoBDERtnTooManyParams,[SQLfile]));
      end
      else
        try
          if Assigned(aTransaction) then Transaction := aTransaction
          else begin
            TmpTr := CreateTransaction(aDataBase);
            Transaction := TmpTr;
          end;
          TransactionStart(TsohoIBTransaction(Transaction));
          PushCursor(crHourGlass);
          ExecQuery;
          Result := True;
          if Assigned(TmpTr) then TransactionCommit(TsohoIBTransaction(Transaction));
        except
          on E: Exception do begin
              if Assigned(TmpTr) then TransactionRollback(TsohoIBTransaction(Transaction));
              TStringList(SQL).SaveToFile(GetPathToLocalTemp+'error.sql');
              if not RoutinesQuiet then
                ErrorMsg(Format(sohoBDERtnOpenError, [SQLfile, E.message]));
             raise;
          end;
        end;
    end;
  finally
    TmpQ.Free;
    if not Assigned(aTransaction) then TmpTr.Free;
    RestoreCursor;
  end;
end;

function ExecuteSQLText(const SQLText: string; aDataBase: TsohoIBDataBase;
         aTransaction : TsohoIBTransaction; SQLParams: array of string): boolean;
var TmpQ: TsohoIBSQL;
    TmpTr: TsohoIBTransaction;
begin
  Result := False;
  TmpTr := nil;
  TmpQ := TsohoIBSQL.Create(nil);
  try
    with TmpQ, SQL do begin
      DataBase := aDataBase;
      SQL.Text := SQLText;
      if (not PutParameteres(TStringList(SQL), SQLParams)) and
        (not RoutinesQuiet) then begin
        ErrorMsg(Format(sohoBDERtnTooManyParams,[SQLText]));
      end
      else
        try
          if Assigned(aTransaction) then Transaction := aTransaction
          else begin
            TmpTr := CreateTransaction(aDataBase);
            Transaction := TmpTr;
          end;
          TransactionStart(TsohoIBTransaction(Transaction));
          PushCursor(crHourGlass);
          ExecQuery;
          Result := True;
          if Assigned(TmpTr) then TransactionCommit(TsohoIBTransaction(Transaction));
        except
          on E: Exception do begin
              if Assigned(TmpTr) then TransactionRollback(TsohoIBTransaction(Transaction));
              TStringList(SQL).SaveToFile(GetPathToLocalTemp+'error.sql');
              if not RoutinesQuiet then
                ErrorMsg(Format(sohoBDERtnOpenError, [SQLText, E.message]));
             raise;
          end;
        end;
    end;
  finally
    TmpQ.Free;
    if not Assigned(aTransaction) then TmpTr.Free;
    RestoreCursor;
  end;
end;

const IBBools : array[boolean] of byte = (0, 1);
const IBBoolsStr : array[boolean] of ShortString = ('0', '1');

function BoolToIB (Value: boolean) : integer;
begin
  Result := IBBools[Value];
end;

function BoolToIBStr (Value: boolean) : string;
begin
  Result := IBBoolsStr[Value];
end;
initialization
  RoutinesQuiet := False;
  ShowSQLBeforeExecute := False;
end.
