{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{           Copyright (c) 2000-2001 Devrace             }
{              Written by Igor Chernyshov               }
{                                                       }
{            Devrace SohoIBLib Pro Components           }
{           This library is a trustware product         }
{            Please, read the License.txt file          }
{                                                       }
{             url   : http://www.devrace.com/           }
{             e-mail: sohoiblib@devrace.com             }
{                                                       }
{*******************************************************}
{
      TsohoIBAssist
  06.11.2000 -    GeneratorName
}

{$I SOHOIBLIB.INC}

unit SohoIBAssistProps;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, SohoIBAssist,
  StdCtrls, SoCtrls, ComCtrls, SoListView, SohoBtns, Controls,
  {$IFDEF Delphi6}DesignEditors, DesignIntf{$ELSE}DsgnIntf{$ENDIF};

type

{$IFNDEF Delphi4_or_5}
  IDesigner = TDesigner;
{$ENDIF}

  TSoIBAssistDlg = class(TForm)
    TableL: TsohoLabel;
    KeyL: TsohoLabel;
    FieldsL: TsohoLabel;
    FieldsList: TListBox;
    AddButton: TsohoBitBtn;
    ComponentsL: TsohoLabel;
    ComponentsList: TListBox;
    LinkL: TsohoLabel;
    StoredList: TsohoListView;
    DeleteButton: TsohoBitBtn;
    ClearButton: TsohoBitBtn;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    scb_KeyField: TsohoComboBox;
    scb_TableName: TsohoComboBox;
    GenL: TsohoLabel;
    scb_GeneratorName: TsohoComboBox;
    procedure AddButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FCompOwner : TComponent;
    FDesigner  : IDesigner;
    IBAssist   : TsohoIBAssist;
    procedure AddLink(const FName, CName : string);
  public
    procedure SetData(fl, sl : TStrings);
  end;

  { TFormIBAssistEditor }
  TsohoFormIBAssistEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

var
  SoIBAssistDlg: TSoIBAssistDlg;

{ Show component editor }
function ShowIBAssistDesigner(IBA : TsohoIBAssist; ACompOwner: TComponent; ADesigner: IDesigner;
  var Table_Name, Key_Field, Generator_Name : string; var Fields_List, Edits_List : TStrings): Boolean;

implementation
uses SoVCLUtils, SoIBUtil, SoChkBox, SoIBComb, SoIBClasses, SoDialogs,
     SoIBCns, SoCmnCns;

{$R *.DFM}

//-----------------------------------------------------------------------------
// TsohoFormIBAssistEditor
//-----------------------------------------------------------------------------
procedure TsohoFormIBAssistEditor.ExecuteVerb(Index: Integer);
var
  IBAssist: TsohoIBAssist;
  tn, kf, gn : string;
  fl, el : TStringList;
begin
  IBAssist := Component as TsohoIBAssist;
  if Index = 0 then begin
    tn := IBAssist.TableName;
    kf := IBAssist.KeyField;
    gn := IBAssist.GeneratorName;
    fl := TStringList.Create;
    el := TStringList.Create;
    fl.Assign(IBAssist.FieldsList);
    el.Assign(IBAssist.EditsList);
    if ShowIBAssistDesigner(IBAssist, TComponent(IBAssist.Owner), Designer,
                         tn, kf, gn,
                         TStrings(fl), TStrings(el))
    then begin
      IBAssist.TableName     := tn;
      IBAssist.KeyField      := kf;
      IBAssist.GeneratorName := gn;
      IBAssist.FieldsList.Assign(fl);
      IBAssist.EditsList.Assign(el);
      Designer.Modified;
    end; {--- if ---}
    fl.Free;
    el.Free;
  end;
end;

function TsohoFormIBAssistEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'IB&Assist Designer';
    else Result := '';
  end;
end;

function TsohoFormIBAssistEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{ Show component editor }
function ShowIBAssistDesigner(IBA : TsohoIBAssist; ACompOwner: TComponent; ADesigner: IDesigner;
  var Table_Name, Key_Field, Generator_Name : string; var Fields_List, Edits_List : TStrings): Boolean;
var
  i : Integer;
begin
  with TSoIBAssistDlg.Create(Application) do
  try
    FCompOwner             := ACompOwner;
    FDesigner              := ADesigner;
    IBAssist               := IBA;
    scb_TableName.Text     := Table_Name;
    scb_KeyField.Text      := Key_Field;
    scb_GeneratorName.Text := Generator_Name;
    SetData(Fields_List, Edits_List);
    Result := ShowModal = mrOk;
    if Result then begin
      Table_Name     := scb_TableName.Text;
      Key_Field      := scb_KeyField.Text;
      Generator_Name := scb_GeneratorName.Text;
      Fields_List.Clear;
      Edits_List.Clear;
      for i := 0  to Pred(StoredList.Items.Count) do begin
        Fields_List.Add(StoredList.Items[I].Caption);
        Edits_List.Add(StoredList.Items[I].SubItems.Strings[0]);
      end; {--- for ---}
    end;
  finally
    Free;
  end;
end;

//-----------------------------------------------------------------------------
// TTSoIBAssistDlg
//-----------------------------------------------------------------------------
procedure TSoIBAssistDlg.AddLink(const FName, CName : string);
var
  TL : TListItem;
begin
  TL := StoredList.Items.Add;
  TL.Caption := FName;
  TL.SubItems.Add(CName);
end;

procedure TSoIBAssistDlg.SetData(fl, sl : TStrings);
var
  i : Integer;
  Q : TsohoIBSQL;
  DBState,
  TrState,
  DSState  : Boolean;
begin
  //  StoredList
  StoredList.Items.Clear;
  for i := 0 to pred(fl.Count) do AddLink(fl[i], sl[i]);

  //  
  ComponentsList.Clear;
  for i := 0 to pred(FCompOwner.ComponentCount) do begin
    if (FCompOwner.Components[i] is TsohoFlatEdit)   OR
       (FCompOwner.Components[i] is TsohoCheckBox)   OR
       (FCompOwner.Components[i] is TsohoLabel)      OR
       (FCompOwner.Components[i] is TsohoComboBox)   OR
       (FCompOwner.Components[i] is TCustomMemo)     OR
       (FCompOwner.Components[i] is TCustomRichEdit) OR
       (FCompOwner.Components[i] is TsohoIBComboBox)
    then begin
      ComponentsList.Items.Add(FCompOwner.Components[i].Name);
    end;
  end;  {--- for ---}
  ComponentsList.Sorted := True;

  //    DataSet.  DataSet = nil  -  
  FieldsList.Clear;
  if IBAssist.DataSet = nil then Exit;

  //  DataSet
  DBState := TsohoIBDataSet(IBAssist.DataSet).Database.Connected;
  if not DBState then
    try
      { statements to try }
      TsohoIBDataSet(IBAssist.DataSet).Database.Open;
    except
      exit;
    end;    { try/except }

  TrState := TsohoIBDataSet(IBAssist.DataSet).Transaction.Active;
  if not TrState then
    try
      { statements to try }
      TsohoIBDataSet(IBAssist.DataSet).Transaction.StartTransaction;
    except
      exit;
    end;    { try/except }

  DsState := IBAssist.DataSet.Active;
  if not DsState then
    try
      { statements to try }
      IBAssist.DataSet.Open;
    except
      TsohoIBDataSet(IBAssist.DataSet).Transaction.Rollback;
      TsohoIBDataSet(IBAssist.DataSet).Database.Close;
      exit;
    end;    { try/except }

  //  
  IBAssist.DataSet.GetFieldNames(FieldsList.Items);
  scb_KeyField.Items.Assign(FieldsList.Items);
  FieldsList.Sorted := True;

  q := TsohoIBSQL.Create(nil);
  try
    //   
    q.Database := TsohoIBDataSet(IBAssist.DataSet).Database;
    q.Transaction := TsohoIBDataSet(IBAssist.DataSet).Transaction;
    q.SQL.Add('select RDB$RELATION_NAME as TableName, RDB$DESCRIPTION from RDB$RELATIONS where (RDB$SYSTEM_FLAG = 0)');
    q.SQL.Add('and (RDB$VIEW_SOURCE is Null)');
    q.SQL.Add('order by RDB$RELATION_NAME');
    q.ExecSQL;
    //scb_TableName.Clear;
    while NOT(Q.EOF) do begin
      scb_TableName.Items.Add(Trim(q.Fields[0].AsString));
      q.Next;
    end; {--- while ---}
    q.Close;

    //   
    q.SQL.Clear;
    q.SQL.Add('select RDB$GENERATOR_NAME from RDB$GENERATORS where (RDB$SYSTEM_FLAG = 0) or ');
    q.SQL.Add('(RDB$SYSTEM_FLAG is null) order by RDB$GENERATOR_NAME');
    q.ExecSQL;
    //scb_TableName.Clear;
    while NOT(Q.EOF) do begin
      scb_GeneratorName.Items.Add(Trim(q.Fields[0].AsString));
      q.Next;
    end; {--- while ---}

  finally
    q.Close;
    //     
    if not DsState then IBAssist.DataSet.Close;
    if not TrState then TsohoIBDataSet(IBAssist.DataSet).Transaction.Commit
                   else TsohoIBDataSet(IBAssist.DataSet).Transaction.CommitRetaining;
    if not DBState then TsohoIBDataSet(IBAssist.DataSet).Database.Close;
  end;
end;

// Add Link
procedure TSoIBAssistDlg.AddButtonClick(Sender: TObject);
begin
  if (FieldsList.itemIndex >=0) AND
     (ComponentsList.itemIndex >=0) then
       AddLink(FieldsList.Items[FieldsList.itemIndex],
               ComponentsList.Items[ComponentsList.ItemIndex]);
end;

// Delete Link
procedure TSoIBAssistDlg.DeleteButtonClick(Sender: TObject);
begin
  if StoredList.Selected = nil then Exit;
  StoredList.Selected.Delete;
end;

// Clear All Links
procedure TSoIBAssistDlg.ClearButtonClick(Sender: TObject);
begin
  if YesNoMsg('You are sure ?') then StoredList.Items.Clear;
end;

procedure TSoIBAssistDlg.FormCreate(Sender: TObject);
begin

  Caption := sohoIBAssistEditorTitle;
  TableL.Caption := sohoIBAssistTable;
  KeyL.Caption := sohoIBAssistKey;
  FieldsL.Caption := sohoIBAssistFields;
  AddButton.Caption := sohoIBAssistAddButton;
  ComponentsL.Caption := sohoIBAssistComponents;
  LinkL.Caption := sohoIBAssistLink;
  DeleteButton.Caption := sohoIBAssistDeleteButton;
  ClearButton.Caption := sohoIBAssistClearButton;
  GenL.Caption := sohoIBAssistGenerator;

  OkB.Caption := SOKButton;
  CancelB.Caption := SCancelButton;
end;

end.
